package gov.va.med.hac.edi.extract.x214;

import gov.va.med.domain.erepos.ClaimDt;
import gov.va.med.domain.erepos.DentalSvcLine;
import gov.va.med.domain.erepos.FunctionalGroup;
import gov.va.med.domain.erepos.InstSvcLine;
import gov.va.med.domain.erepos.PatientInfo;
import gov.va.med.domain.erepos.PrfsnSvcLine;
import gov.va.med.domain.erepos.RejectClaim;
import gov.va.med.domain.erepos.TxnSet;

import java.io.File;
import java.io.PrintWriter;
import java.math.BigDecimal;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.persistence.Query;

import org.hibernate.ScrollMode;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * 
 * @author DNS
 *
 */
public class Build277CASegments extends Build277CAStatusInformation {
	static final Logger LOGGER = LoggerFactory
			.getLogger(Build277CASegments.class);
	private final static String COMPONENT_ELEMENT_SEPARATOR = ":";
	private final static String DATA_ELEMENT_SEPARATOR = "*";
	private final static String SEGMENT_TERMINATOR = "~";
	private final static String REPETITION_SEPARATOR = "^";
	File csFile = null;
	int cnt = 0;
	final String CRLF = "\r\n";
	PrintWriter vCsFile = null;
	String filePath = "";
	String sClaimKey = "";
	EntityName senderInfo = null;
	EntityName receiverInfo = null;
	EntityName billingProviderInfo = null;
	EntityName oPatient = null;
	List<EntityName> listEntityName = null;
	PatientInfo oPatientInfo = null;
	FunctionalGroup oFunctionalGroup = null;
	TxnSet oTxnSet = null;
	boolean bInClaim = true;
	String strSTC01 = null;
	String strSTC10 = null;
	String strSTC11 = null;

	/**
	 * 
	 * @param claim
	 * @param ediClaimKey
	 */
	protected void createISAHeaderBatch() {
		LOGGER.debug("Begin Creating ISAHeader");
		StringBuffer sbHdrRec = new StringBuffer();
		sbHdrRec.append("ISA");
		dataElementSeparator(sbHdrRec);
		sbHdrRec.append("00");
		dataElementSeparator(sbHdrRec);
		sbHdrRec.append("          ");
		dataElementSeparator(sbHdrRec);
		sbHdrRec.append("00");
		dataElementSeparator(sbHdrRec);
		sbHdrRec.append("          ");
		dataElementSeparator(sbHdrRec);
		sbHdrRec.append("ZZ");
		dataElementSeparator(sbHdrRec);
		sbHdrRec.append(getReceiverId());
		dataElementSeparator(sbHdrRec);
		sbHdrRec.append("ZZ");
		dataElementSeparator(sbHdrRec);
		sbHdrRec.append(getSenderId());
		dataElementSeparator(sbHdrRec);
		sbHdrRec.append(getCreatedDateyyMMdd());
		dataElementSeparator(sbHdrRec);
		sbHdrRec.append(getCreatedTimeHHmm());
		dataElementSeparator(sbHdrRec);
		repetationSeperator(sbHdrRec);
		dataElementSeparator(sbHdrRec);
		// Interchange Control Version Number
		sbHdrRec.append("00501");
		dataElementSeparator(sbHdrRec);
		// Interchange Control Number
		sbHdrRec.append(getInterChangeCtrlNumber());
		dataElementSeparator(sbHdrRec);
		// Acknowledgment Requested
		sbHdrRec.append("0");
		dataElementSeparator(sbHdrRec);
		// Interchange Usage Indicator
		sbHdrRec.append("P");
		dataElementSeparator(sbHdrRec);
		componentElementSeparator(sbHdrRec);
		segmentTerminator(sbHdrRec);
		sbHdrRec.append(CRLF);
		vCsFile.print(sbHdrRec);
		vCsFile.flush();
		sbHdrRec = null;
		LOGGER.debug("End Creating ISAHeader");
	}

	/**
	 * 
	 */
	protected void createGSBatch() {
		LOGGER.debug("Begin Creating GS Segment");
		StringBuffer strGS = new StringBuffer();
		setFunctionalGroup();
		strGS.append("GS");
		dataElementSeparator(strGS);
		strGS.append("HN");
		dataElementSeparator(strGS);
		strGS.append(getCheckNull(oFunctionalGroup.getGs03appRcvCd()));
		dataElementSeparator(strGS);
		strGS.append(getCheckNull(oFunctionalGroup.getGs02appSndCd()));
		dataElementSeparator(strGS);
		strGS.append(getCreatedDateyyyyMMdd());
		dataElementSeparator(strGS);
		strGS.append(getCreatedTimeHHmmssSS());
		dataElementSeparator(strGS);
		// Interchange Control Number
		strGS.append(getCheckNull(oFunctionalGroup.getGs06grpCtlNbr()));
		dataElementSeparator(strGS);
		strGS.append(getCheckNull(oFunctionalGroup.getGs07respAgcyCd()));
		dataElementSeparator(strGS);
		strGS.append("005010X214");
		segmentTerminator(strGS);
		strGS.append(CRLF);
		vCsFile.print(strGS);
		vCsFile.flush();
		strGS = null;
		LOGGER.debug("End Creating GS Segment");
	}

	/**
	 * 
	 */
	protected void createST() {
		cnt = 0;
		LOGGER.debug("Begin Creating ST Segment");
		StringBuffer strST = new StringBuffer();
		strST.append("ST");
		dataElementSeparator(strST);
		strST.append("277");
		dataElementSeparator(strST);
		// Transaction Control Number
		strST.append(reposClaim.getSt02txnCtlNbr());
		dataElementSeparator(strST);
		strST.append("005010X214");
		segmentTerminator(strST);
		strST.append(CRLF);
		vCsFile.print(strST);
		vCsFile.flush();
		strST = null;
		cnt++;
		LOGGER.debug("End Creating ST Segment");
	}

	/**
	 * 
	 */
	protected void createBHT() {
		LOGGER.debug("Begin Creating BHT Segment");
		setBHT();
		StringBuffer strBHT = new StringBuffer();
		strBHT.append("BHT");
		dataElementSeparator(strBHT);
		strBHT.append("0085");
		dataElementSeparator(strBHT);
		strBHT.append("08");
		dataElementSeparator(strBHT);
		// Reference Identification...
		strBHT.append(oTxnSet.getBht03orgnTxnId());
		dataElementSeparator(strBHT);
		strBHT.append(getCreatedDateyyyyMMdd());
		dataElementSeparator(strBHT);
		strBHT.append(getCreatedTimeHHmmssSS());
		dataElementSeparator(strBHT);
		strBHT.append("TH");
		segmentTerminator(strBHT);
		strBHT.append(CRLF);
		vCsFile.print(strBHT);
		vCsFile.flush();
		strBHT = null;
		cnt++;
		LOGGER.debug("End Creating BHT Segment");
	}

	/**
	 * 
	 */
	protected void createHL1() {
		LOGGER.debug("Begin Creating HL1 Segment");
		StringBuffer strHL1 = new StringBuffer();
		strHL1.append("HL");
		dataElementSeparator(strHL1);
		strHL1.append("1");
		dataElementSeparator(strHL1);
		dataElementSeparator(strHL1);
		strHL1.append("20");
		dataElementSeparator(strHL1);
		strHL1.append("1");
		segmentTerminator(strHL1);
		strHL1.append(CRLF);
		vCsFile.print(strHL1);
		vCsFile.flush();
		strHL1 = null;
		cnt++;
		LOGGER.debug("End Creating HL1 Segment");
	}

	/**
	 * Create Organization Information...
	 */
	protected void createNM1_1() {
		LOGGER.debug("Begin Creating NM1 Segment");
		StringBuffer strNM1 = new StringBuffer();
		strNM1.append("NM1");
		dataElementSeparator(strNM1);
		strNM1.append("PR");
		if (null != this.receiverInfo) {
			String temp = "";
			dataElementSeparator(strNM1);
			strNM1.append(receiverInfo.getNm102entyQual());
			dataElementSeparator(strNM1);
			strNM1.append(getCheckNull(receiverInfo.getNm103lastNm()));
			dataElementSeparator(strNM1);
			strNM1.append(getCheckNull(receiverInfo.getNm104fstNm()));
			dataElementSeparator(strNM1);
			strNM1.append(getCheckNull(receiverInfo.getNm105midNm()));
			dataElementSeparator(strNM1);
			strNM1.append(getCheckNull(receiverInfo.getNm106nmPfx()));
			dataElementSeparator(strNM1);
			strNM1.append(getCheckNull(receiverInfo.getNm107nmSfx()));
			dataElementSeparator(strNM1);
			strNM1.append(getCheckNull(receiverInfo.getNm108idCdQual()));
			dataElementSeparator(strNM1);
			// Identification Code X AN
			strNM1.append(getCheckNull(receiverInfo.getNm109idCd()));
			temp = getCheckNull(receiverInfo.getNm110entyRelCd());
			if (temp != null && temp.length() > 0) {
				dataElementSeparator(strNM1);
				strNM1.append(temp);
			}

			temp = getCheckNull(receiverInfo.getNm111entyIdCd());
			if (temp != null && temp.length() > 0) {
				dataElementSeparator(strNM1);
				strNM1.append(temp);
			}

			temp = getCheckNull(receiverInfo.getNm112lastNmOrganizNm());
			if (temp != null && temp.length() > 0) {
				dataElementSeparator(strNM1);
				strNM1.append(temp);
			}
		}
		segmentTerminator(strNM1);
		strNM1.append(CRLF);
		vCsFile.print(strNM1);
		vCsFile.flush();
		strNM1 = null;
		cnt++;
		LOGGER.debug("End Creating NM1 Segment");
	}

	/**
	 * 
	 */
	protected void createTRN1() {
		LOGGER.debug("Begin Creating TRN1 Segment");
		StringBuffer strTRN1 = new StringBuffer();
		strTRN1.append("TRN");
		dataElementSeparator(strTRN1);
		strTRN1.append("1");
		dataElementSeparator(strTRN1);
		strTRN1.append(getInterChangeCtrlNumber());
		segmentTerminator(strTRN1);
		strTRN1.append(CRLF);
		vCsFile.print(strTRN1);
		vCsFile.flush();
		strTRN1 = null;
		cnt++;
		LOGGER.debug("End Creating TRN1 Segment");
	}

	/**
	 * 
	 */
	protected void createDTP1() {
		LOGGER.debug("Begin Creating DTP1 Segment");
		StringBuffer strDTP1 = new StringBuffer();
		strDTP1.append("DTP");
		dataElementSeparator(strDTP1);
		strDTP1.append("050");
		dataElementSeparator(strDTP1);
		strDTP1.append("D8");
		dataElementSeparator(strDTP1);
		strDTP1.append(getCreatedDateyyyyMMdd());
		segmentTerminator(strDTP1);
		strDTP1.append(CRLF);
		vCsFile.print(strDTP1);
		vCsFile.flush();
		strDTP1 = null;
		cnt++;
		LOGGER.debug("End Creating DTP1 Segment");
	}

	/**
	 * 
	 */
	protected void createDTP2() {
		LOGGER.debug("Begin Creating DTP2 Segment");
		StringBuffer strDTP2 = new StringBuffer();
		strDTP2.append("DTP");
		dataElementSeparator(strDTP2);
		strDTP2.append("009");
		dataElementSeparator(strDTP2);
		strDTP2.append("D8");
		dataElementSeparator(strDTP2);
		strDTP2.append(getCreatedDateyyyyMMdd());
		dataElementSeparator(strDTP2);
		segmentTerminator(strDTP2);
		strDTP2.append(CRLF);
		vCsFile.print(strDTP2);
		vCsFile.flush();
		strDTP2 = null;
		cnt++;
		LOGGER.debug("End Creating DTP2 Segment");
	}

	/**
	 * 
	 */
	protected void createHL2() {
		LOGGER.debug("Begin Creating HL2 Segment");
		StringBuffer strHL2 = new StringBuffer();
		strHL2.append("HL");
		dataElementSeparator(strHL2);
		strHL2.append("2");
		dataElementSeparator(strHL2);
		strHL2.append("1");
		dataElementSeparator(strHL2);
		strHL2.append("21");
		dataElementSeparator(strHL2);
		strHL2.append("1");
		segmentTerminator(strHL2);
		strHL2.append(CRLF);
		vCsFile.print(strHL2);
		vCsFile.flush();
		strHL2 = null;
		cnt++;
		LOGGER.debug("End Creating HL2 Segment");
	}

	/**
	 * 
	 */
	protected void createNM1_2() {
		LOGGER.debug("Begin Creating NM1 receiver Segment");
		StringBuffer strNM1 = new StringBuffer();
		strNM1.append("NM1");
		dataElementSeparator(strNM1);
		strNM1.append("41");
		if (null != this.senderInfo) {
			String temp = "";
			dataElementSeparator(strNM1);
			strNM1.append(senderInfo.getNm102entyQual());
			dataElementSeparator(strNM1);
			strNM1.append(getCheckNull(senderInfo.getNm103lastNm()));
			dataElementSeparator(strNM1);
			strNM1.append(getCheckNull(senderInfo.getNm104fstNm()));
			dataElementSeparator(strNM1);
			strNM1.append(getCheckNull(senderInfo.getNm105midNm()));
			dataElementSeparator(strNM1);
			strNM1.append(getCheckNull(senderInfo.getNm106nmPfx()));
			dataElementSeparator(strNM1);
			strNM1.append(getCheckNull(senderInfo.getNm107nmSfx()));
			dataElementSeparator(strNM1);
			strNM1.append(getCheckNull(senderInfo.getNm108idCdQual()));
			dataElementSeparator(strNM1);
			strNM1.append(getCheckNull(senderInfo.getNm109idCd()));
			temp = getCheckNull(senderInfo.getNm110entyRelCd());
			if (temp != null && temp.length() > 0) {
				dataElementSeparator(strNM1);
				strNM1.append(temp);
			}
			temp = getCheckNull(senderInfo.getNm111entyIdCd());
			if (temp != null && temp.length() > 0) {
				dataElementSeparator(strNM1);
				strNM1.append(temp);
			}
			temp = getCheckNull(senderInfo.getNm112lastNmOrganizNm());
			if (temp != null && temp.length() > 0) {
				dataElementSeparator(strNM1);
				strNM1.append(temp);
			}
		}
		segmentTerminator(strNM1);
		strNM1.append(CRLF);
		vCsFile.print(strNM1);
		vCsFile.flush();
		strNM1 = null;
		cnt++;
		LOGGER.debug("End Creating NM1 receiver Segment");
	}

	/**
	 * 
	 */
	protected void createTRN2() {
		LOGGER.debug("Begin Creating TRN receiver Segment");
		StringBuffer strTRN2 = new StringBuffer();
		strTRN2.append("TRN");
		dataElementSeparator(strTRN2);
		strTRN2.append("2");
		dataElementSeparator(strTRN2);
		strTRN2.append(this.getInterChangeCtrlNumber());
		segmentTerminator(strTRN2);
		strTRN2.append(CRLF);
		vCsFile.print(strTRN2);
		vCsFile.flush();
		strTRN2 = null;
		cnt++;
		LOGGER.debug("End Creating TRN receiver Segment");
	}

	/**
	 * 
	 */
	protected void createSTC1() {
		LOGGER.debug("Begin Creating STC1 Segment");
		StringBuffer strSTC = new StringBuffer();
		strSTC.append("STC");
		dataElementSeparator(strSTC);

		if (null != reposClaim.getStatusCode()
				&& reposClaim.getStatusCode().equals(REJECTED)) {
			strSTC.append("A3:21");
			dataElementSeparator(strSTC);
			strSTC.append(getCreatedDateyyyyMMdd());
			dataElementSeparator(strSTC);
			strSTC.append("U");
		} else {
			strSTC.append("A1:19");
			dataElementSeparator(strSTC);
			strSTC.append(getCreatedDateyyyyMMdd());
			dataElementSeparator(strSTC);
			strSTC.append("WQ");
		}
		dataElementSeparator(strSTC);
		if (null != reposClaim.getClm02clmChrgAmt()) {
			strSTC.append(reposClaim.getClm02clmChrgAmt());
		}
		segmentTerminator(strSTC);
		strSTC.append(CRLF);
		vCsFile.print(strSTC);
		vCsFile.flush();
		strSTC = null;
		cnt++;
		LOGGER.debug("End Creating STC1 Segment");
	}

	/**
	 * 
	 */
	protected void createQTY() {
		LOGGER.debug("Begin Creating QTY Segment");
		StringBuffer strQTY = new StringBuffer();
		strQTY.append("QTY");
		dataElementSeparator(strQTY);
		if (this.ACCEPTED.equals(reposClaim.getStatusCode())) {
			strQTY.append("90");
		} else {
			strQTY.append("AA");
		}
		dataElementSeparator(strQTY);
		if (null != listDentalSvcLine && listDentalSvcLine.size() > 0) {
			strQTY.append(listDentalSvcLine.get(0).getSv306procCnt());
		} else {
			strQTY.append("1");
		}
		segmentTerminator(strQTY);
		strQTY.append(CRLF);
		vCsFile.print(strQTY);
		vCsFile.flush();
		strQTY = null;
		cnt++;
		LOGGER.debug("End Creating QTY Segment");
	}

	/**
	 * 
	 */
	protected void createAMT() {
		LOGGER.debug("Begin Creating AMT Segment");
		StringBuffer strAMT = new StringBuffer();
		strAMT.append("AMT");
		dataElementSeparator(strAMT);
		if (ACCEPTED.equals(reposClaim.getStatusCode())) {
			strAMT.append("YU");
		} else {
			strAMT.append("YY");
		}
		dataElementSeparator(strAMT);
		strAMT.append(this.reposClaim.getClm02clmChrgAmt());
		segmentTerminator(strAMT);
		strAMT.append(CRLF);
		vCsFile.print(strAMT);
		vCsFile.flush();
		strAMT = null;
		cnt++;
		LOGGER.debug("End Creating AMT Segment");
	}

	/**
	 * 
	 */
	protected void createHL3() {
		LOGGER.debug("Begin Creating HL Segment Billing Provider");
		StringBuffer strHL = new StringBuffer();
		strHL.append("HL");
		dataElementSeparator(strHL);
		strHL.append("3");
		dataElementSeparator(strHL);
		strHL.append("2");
		dataElementSeparator(strHL);
		strHL.append("19");
		dataElementSeparator(strHL);
		strHL.append("1");
		segmentTerminator(strHL);
		strHL.append(CRLF);
		vCsFile.print(strHL);
		vCsFile.flush();
		strHL = null;
		cnt++;
		LOGGER.debug("End Creating HL Segment Billing Provider");
	}

	/**
	 * 
	 */
	protected void createNM1_3() {
		LOGGER.debug("Begin Creating NM1 Billing Provider");
		StringBuffer strNM1 = new StringBuffer();
		strNM1.append("NM1");
		dataElementSeparator(strNM1);
		strNM1.append("85");
		if (null != billingProviderInfo) {
			String temp = "";
			dataElementSeparator(strNM1);
			strNM1.append(billingProviderInfo.getNm102entyQual());
			temp = getCheckNull(billingProviderInfo.getNm103lastNm());
			if (null != temp && temp.length() > 0) {
				dataElementSeparator(strNM1);
				strNM1.append(temp);
			}
			temp = getCheckNull(billingProviderInfo.getNm104fstNm());
			if (null != temp && temp.length() > 0) {
				dataElementSeparator(strNM1);
				strNM1.append(temp);
			}
			temp = getCheckNull(billingProviderInfo.getNm105midNm());
			if (null != temp && temp.length() > 0) {
				dataElementSeparator(strNM1);
				strNM1.append(temp);
			}
			temp = getCheckNull(billingProviderInfo.getNm106nmPfx());
			if (null != temp && temp.length() > 0) {
				dataElementSeparator(strNM1);
				strNM1.append(temp);
			}

			temp = getCheckNull(billingProviderInfo.getNm107nmSfx());
			if (null != null & temp.length() > 0) {
				dataElementSeparator(strNM1);
				strNM1.append(temp);
			}
			temp = getCheckNull(billingProviderInfo.getNm109ptntId());
			if (temp != null && temp.length() > 0) {
				String temp1 = getCheckNull(billingProviderInfo
						.getNm108idCdQual());
				if (temp1 != null && temp1.length() > 0) {
					dataElementSeparator(strNM1);
					strNM1.append(temp1);
				}
				dataElementSeparator(strNM1);
				strNM1.append(temp);
			}
		}
		segmentTerminator(strNM1);
		strNM1.append(CRLF);
		vCsFile.print(strNM1);
		vCsFile.flush();
		strNM1 = null;
		cnt++;
		LOGGER.debug("End Creating NM1 Billing Provider");
	}

	/**
	 * 
	 */
	protected void createTRN3() {
		LOGGER.debug("Begin Creating TRN Billing Provider");
		StringBuffer strTRN3 = new StringBuffer();
		strTRN3.append("TRN");
		dataElementSeparator(strTRN3);
		strTRN3.append("1");
		dataElementSeparator(strTRN3);
		strTRN3.append(this.getInterChangeCtrlNumber());
		segmentTerminator(strTRN3);
		strTRN3.append(CRLF);
		vCsFile.print(strTRN3);
		vCsFile.flush();
		strTRN3 = null;
		cnt++;
		LOGGER.debug("End Creating TRN Billing Provider");
	}

	/**
	 * 
	 */
	protected void createSTC2() {
		LOGGER.debug("Begin Creating STC2");
		StringBuffer strSTC = new StringBuffer();
		strSTC.append("STC");
		dataElementSeparator(strSTC);
		if (null != reposClaim.getStatusCode()
				&& reposClaim.getStatusCode().equals(REJECTED)) {
			strSTC.append("A3:21");
		} else {
			strSTC.append("A2:20");
		}

		dataElementSeparator(strSTC);
		strSTC.append(getCreatedDateyyyyMMdd());
		dataElementSeparator(strSTC);
		if (null != reposClaim.getStatusCode()
				&& reposClaim.getStatusCode().equals(REJECTED)) {
			strSTC.append("U");
		} else {
			strSTC.append("WQ");
		}
		dataElementSeparator(strSTC);
		if (null != reposClaim.getClm02clmChrgAmt()) {
			strSTC.append(reposClaim.getClm02clmChrgAmt());
		}
		segmentTerminator(strSTC);
		strSTC.append(CRLF);
		vCsFile.print(strSTC);
		vCsFile.flush();
		strSTC = null;
		cnt++;
		LOGGER.debug("End Creating STC2");
	}

	/**
	 * 
	 */
	protected void createHL4() {
		LOGGER.debug("Begin Creating HL Patient Info");
		StringBuffer strHL = new StringBuffer();
		strHL.append("HL");
		dataElementSeparator(strHL);
		strHL.append("4");
		dataElementSeparator(strHL);
		strHL.append("3");
		dataElementSeparator(strHL);
		strHL.append("PT");
		segmentTerminator(strHL);
		strHL.append(CRLF);
		vCsFile.print(strHL);
		vCsFile.flush();
		strHL = null;
		cnt++;
		LOGGER.debug("End Creating HL Patient Info");
	}

	/**
	 * 
	 */
	protected void createNM1_4() {
		LOGGER.debug("Begin Creating Nm1 Patient Info");
		StringBuffer strNM1 = new StringBuffer();
		strNM1.append("NM1");
		dataElementSeparator(strNM1);
		strNM1.append("QC");
		dataElementSeparator(strNM1);
		strNM1.append("1");
		if (null != oPatient) {
			dataElementSeparator(strNM1);
			strNM1.append(getCheckNull(oPatient.getNm103lastNm()));
			dataElementSeparator(strNM1);
			strNM1.append(getCheckNull(oPatient.getNm104fstNm()));
			dataElementSeparator(strNM1);
			strNM1.append(getCheckNull(oPatient.getNm105midNm()));
			dataElementSeparator(strNM1);
			strNM1.append(getCheckNull(oPatient.getNm106nmPfx()));
			dataElementSeparator(strNM1);
			strNM1.append(getCheckNull(oPatient.getNm107nmSfx()));
		}
		dataElementSeparator(strNM1);
		strNM1.append("MI");
		if (null != oPatient) {
			dataElementSeparator(strNM1);
			strNM1.append(getCheckNull(oPatient.getNm109ptntId()));
		}
		segmentTerminator(strNM1);
		strNM1.append(CRLF);
		vCsFile.print(strNM1);
		vCsFile.flush();
		strNM1 = null;
		cnt++;
		LOGGER.debug("End Creating Nm1 Patient Info");
	}

	/**
	 * 
	 */
	protected void createTRN4() {
		LOGGER.debug("Begin Creating TRN Patient Info");
		StringBuffer strTRN4 = new StringBuffer();
		oPatientInfo = getPatientInfo();
		strTRN4.append("TRN");
		dataElementSeparator(strTRN4);
		strTRN4.append("2");
		dataElementSeparator(strTRN4);
		strTRN4.append(reposClaim.getClm01ptAcctNbr());
		segmentTerminator(strTRN4);
		strTRN4.append(CRLF);
		vCsFile.print(strTRN4);
		vCsFile.flush();
		strTRN4 = null;
		cnt++;
		LOGGER.debug("End Creating TRN Patient Info");
	}

	final void createStatusLineInfo() {
		setRejectClaimDate();
		getRejectClaim();
		if (null != listEntityAdtlId && listEntityAdtlId.size() > 0) {
			System.out.println("List of Entity Additional IDs = "
					+ listEntityAdtlId.size());
			for (EntityAdtlId anEntityAdtlId : listEntityAdtlId) {
				if (INST_SVC_LINE.equalsIgnoreCase(reposClaim.getClaimType())
						&& null != anEntityAdtlId.getInstServiceKey()) {
					createRejSVC(anEntityAdtlId, INST_SVC_LINE);
					createRejSTC(anEntityAdtlId, INST_SVC_LINE);
					createRejREF(anEntityAdtlId, INST_SVC_LINE);
					createRejDTP(anEntityAdtlId, INST_SVC_LINE);

				} else if (PRFSN_SVC_LINE.equalsIgnoreCase(reposClaim
						.getClaimType())
						&& null != anEntityAdtlId.getPrfsnServiceKey()) {
					createRejSVC(anEntityAdtlId, PRFSN_SVC_LINE);
					createRejSTC(anEntityAdtlId, PRFSN_SVC_LINE);
					createRejREF(anEntityAdtlId, PRFSN_SVC_LINE);
					createRejDTP(anEntityAdtlId, PRFSN_SVC_LINE);

				} else if (DENTAL_SVC_LINE.equalsIgnoreCase(reposClaim
						.getClaimType())
						&& null != anEntityAdtlId.getDentalServiceKey()) {
					createRejSVC(anEntityAdtlId, DENTAL_SVC_LINE);
					createRejSTC(anEntityAdtlId, DENTAL_SVC_LINE);
					createRejREF(anEntityAdtlId, DENTAL_SVC_LINE);
					createRejDTP(anEntityAdtlId, DENTAL_SVC_LINE);
				}
			}
		}
	}

	/**
	 * 
	 * @param oEntityAdtlId
	 * @param oClaimType
	 */
	final void createRejSVC(EntityAdtlId aEntityAdtlId, String oClaimType) {
		LOGGER.debug("Begin Creating Rej SVC");
		StringBuffer strSVC = new StringBuffer();
		String strSVC1 = "";
		BigDecimal lineItemChrgAmt = null;
		BigDecimal quantity = null;
		String strRevCd = "";
		if (INST_SVC_LINE.equalsIgnoreCase(oClaimType)
				&& null != listInstSvcLine) {
			strSVC1 = buildInstSVC1(aEntityAdtlId);
			lineItemChrgAmt = buildInstItmAmt(aEntityAdtlId);
			quantity = buildInstQuant(aEntityAdtlId);
			strRevCd = buildInstRevCd(aEntityAdtlId);
		}
		if (PRFSN_SVC_LINE.equalsIgnoreCase(oClaimType)
				&& null != listPrfsnSvcLine) {
			strSVC1 = buildPfrsnSVC1(aEntityAdtlId);
			lineItemChrgAmt = buildPfrsnItmChrg(aEntityAdtlId);
			quantity = buildPfrsnUntCt(aEntityAdtlId);
		}
		if (DENTAL_SVC_LINE.equalsIgnoreCase(oClaimType)
				&& null != listDentalSvcLine) {
			strSVC1 = buildDentalSVC1(aEntityAdtlId);
			lineItemChrgAmt = buildDentalItemChrg(aEntityAdtlId);
			quantity = buildDentalUnitCount(aEntityAdtlId);
		}
		strSVC.append("SVC");
		dataElementSeparator(strSVC);
		strSVC.append(strSVC1);
		dataElementSeparator(strSVC);
		strSVC.append(lineItemChrgAmt);
		dataElementSeparator(strSVC);
		if (INST_SVC_LINE.equalsIgnoreCase(oClaimType) && null != strRevCd && strRevCd.length() > 0){
			strSVC.append(strRevCd);
		}
		dataElementSeparator(strSVC);
		dataElementSeparator(strSVC);
		dataElementSeparator(strSVC);
		dataElementSeparator(strSVC);
		strSVC.append(quantity);
		segmentTerminator(strSVC);
		strSVC.append(CRLF);
		vCsFile.print(strSVC);
		vCsFile.flush();
		strSVC = null;
		cnt++;
		LOGGER.debug("End Creating Rej SVC");
	}

	final BigDecimal buildDentalUnitCount(EntityAdtlId aEntityAdtlId) {
		BigDecimal quantity = null;
		for (DentalSvcLine oDentalSvcLine : listDentalSvcLine) {
			if (null != oDentalSvcLine.getServiceKey()
					&& oDentalSvcLine.getServiceKey().equalsIgnoreCase(
							aEntityAdtlId.getDentalServiceKey())
					&& null != oDentalSvcLine.getSv306procCnt()) {
				quantity = oDentalSvcLine.getSv306procCnt();
			}
		}
		return quantity;
	}

	/**
	 * 
	 * @param aEntityAdtlId
	 * @return BigDecimal
	 */
	final BigDecimal buildDentalItemChrg(EntityAdtlId aEntityAdtlId) {
		BigDecimal lineItemChrgAmt = null;
		for (DentalSvcLine oDentalSvcLine : listDentalSvcLine) {
			if (null != oDentalSvcLine.getServiceKey()
					&& oDentalSvcLine.getServiceKey().equalsIgnoreCase(
							aEntityAdtlId.getDentalServiceKey())
					&& null != oDentalSvcLine.getSv302lnItmChrg()) {
				lineItemChrgAmt = oDentalSvcLine.getSv302lnItmChrg();
			}
		}
		return lineItemChrgAmt;
	}

	/**
	 * 
	 * @param aEntityAdtlId
	 * @param strSVC1
	 * @param lineItemChrgAmt
	 */
	final String buildDentalSVC1(EntityAdtlId aEntityAdtlId) {
		StringBuffer strSVC01 = new StringBuffer();
		for (DentalSvcLine oDentalSvcLine : listDentalSvcLine) {
			if (null != oDentalSvcLine.getServiceKey()
					&& oDentalSvcLine.getServiceKey().equalsIgnoreCase(
							aEntityAdtlId.getDentalServiceKey())) {
				if (null != oDentalSvcLine.getSv301adaCdQual()
						&& oDentalSvcLine.getSv301adaCdQual().length() > 0) {
					strSVC01.append(oDentalSvcLine.getSv301adaCdQual());
				}
				if (null != oDentalSvcLine.getSv301adaCd()
						&& oDentalSvcLine.getSv301adaCd().length() > 0) {
					strSVC01.append(":");
					strSVC01.append(oDentalSvcLine.getSv301adaCd());
				}
				if (null != oDentalSvcLine.getSv301procMod1()
						&& oDentalSvcLine.getSv301procMod1().length() > 0) {
					strSVC01.append(":");
					strSVC01.append(oDentalSvcLine.getSv301procMod1());
				}
				if (null != oDentalSvcLine.getSv301procMod2()
						&& oDentalSvcLine.getSv301procMod2().length() > 0) {
					strSVC01.append(":");
					strSVC01.append(oDentalSvcLine.getSv301procMod2());
				}
				if (null != oDentalSvcLine.getSv301procMod3()
						&& oDentalSvcLine.getSv301procMod3().length() > 0) {
					strSVC01.append(":");
					strSVC01.append(oDentalSvcLine.getSv301procMod3());
				}
				if (null != oDentalSvcLine.getSv301procMod4()
						&& oDentalSvcLine.getSv301procMod4().length() > 0) {
					strSVC01.append(":");
					strSVC01.append(oDentalSvcLine.getSv301procMod4());
				}
			}
		}
		return strSVC01.toString();
	}

	/**
	 * 
	 * @param aEntityAdtlId
	 * @return BigDecimal
	 */
	final BigDecimal buildPfrsnItmChrg(EntityAdtlId aEntityAdtlId) {
		BigDecimal lineItemChrgAmt = null;
		for (PrfsnSvcLine oPrfsnSvcLine : listPrfsnSvcLine) {
			if (null != oPrfsnSvcLine.getServiceKey()
					&& oPrfsnSvcLine.getServiceKey().equalsIgnoreCase(
							aEntityAdtlId.getPrfsnServiceKey())
					&& null != oPrfsnSvcLine.getSv102lineItmChrg()) {
				lineItemChrgAmt = oPrfsnSvcLine.getSv102lineItmChrg();
			}
		}
		return lineItemChrgAmt;
	}

	/**
	 * 
	 * @param aEntityAdtlId
	 * @return BigDecimal
	 */
	final BigDecimal buildPfrsnUntCt(EntityAdtlId aEntityAdtlId) {
		BigDecimal quantity = null;
		for (PrfsnSvcLine oPrfsnSvcLine : listPrfsnSvcLine) {
			if (null != oPrfsnSvcLine.getServiceKey()
					&& oPrfsnSvcLine.getServiceKey().equalsIgnoreCase(
							aEntityAdtlId.getPrfsnServiceKey())
					&& null != oPrfsnSvcLine.getSv104svcUnitCnt()) {
				quantity = oPrfsnSvcLine.getSv104svcUnitCnt();
			}
		}
		return quantity;
	}

	/**
	 * 
	 * @param aEntityAdtlId
	 * @param strSVC1
	 * @param lineItemChrgAmt
	 */
	final String buildPfrsnSVC1(EntityAdtlId aEntityAdtlId) {
		StringBuffer strSVC01 = new StringBuffer();
		for (PrfsnSvcLine oPrfsnSvcLine : listPrfsnSvcLine) {
			if (null != oPrfsnSvcLine.getServiceKey()
					&& oPrfsnSvcLine.getServiceKey().equalsIgnoreCase(
							aEntityAdtlId.getPrfsnServiceKey())) {
				if (null != oPrfsnSvcLine.getSv101procCdQual()
						&& oPrfsnSvcLine.getSv101procCdQual().length() > 0) {
					strSVC01.append(oPrfsnSvcLine.getSv101procCdQual());
				}
				if (null != oPrfsnSvcLine.getSv101procCd()
						&& oPrfsnSvcLine.getSv101procCd().length() > 0) {
					strSVC01.append(":");
					strSVC01.append(oPrfsnSvcLine.getSv101procCd());
				}
				if (null != oPrfsnSvcLine.getSv101procMod1()
						&& oPrfsnSvcLine.getSv101procMod1().length() > 0) {
					strSVC01.append(":");
					strSVC01.append(oPrfsnSvcLine.getSv101procMod1());
				}
				if (null != oPrfsnSvcLine.getSv101procMod2()
						&& oPrfsnSvcLine.getSv101procMod2().length() > 0) {
					strSVC01.append(":");
					strSVC01.append(oPrfsnSvcLine.getSv101procMod2());
				}
				if (null != oPrfsnSvcLine.getSv101procMod3()
						&& oPrfsnSvcLine.getSv101procMod3().length() > 0) {
					strSVC01.append(":");
					strSVC01.append(oPrfsnSvcLine.getSv101procMod3());
				}
				if (null != oPrfsnSvcLine.getSv101procMod4()
						&& oPrfsnSvcLine.getSv101procMod4().length() > 0) {
					strSVC01.append(":");
					strSVC01.append(oPrfsnSvcLine.getSv101procMod4());
				}
			}
		}
		return strSVC01.toString();
	}

	final String buildInstRevCd(EntityAdtlId aEntityAdtlId)
	{
		String sRevCd = "";
		for(InstSvcLine oInstSvcLine : listInstSvcLine) {
			if (null != oInstSvcLine.getServiceKey()
					&& oInstSvcLine.getServiceKey().equalsIgnoreCase(
							aEntityAdtlId.getInstServiceKey())
					&& null != oInstSvcLine.getSv201svcLnRevCd()){
				sRevCd = oInstSvcLine.getSv201svcLnRevCd();
			}
		}
		return sRevCd;
	}
	
	/**
	 * 
	 * @param aEntityAdtlId
	 * @return BigDecimal
	 */
	final BigDecimal buildInstQuant(EntityAdtlId aEntityAdtlId) {
		BigDecimal qty = null;
		for (InstSvcLine oInstSvcLine : listInstSvcLine) {
			if (null != oInstSvcLine.getServiceKey()
					&& oInstSvcLine.getServiceKey().equalsIgnoreCase(
							aEntityAdtlId.getInstServiceKey())
					&& null != oInstSvcLine.getSv205svcUnitCnt()) {
				qty = oInstSvcLine.getSv205svcUnitCnt();
			}
		}
		return qty;
	}

	/**
	 * 
	 * @param aEntityAdtlId
	 * @return BigDecimal
	 */
	final BigDecimal buildInstItmAmt(EntityAdtlId aEntityAdtlId) {
		BigDecimal lineItemChrgAmt = null;
		for (InstSvcLine oInstSvcLine : listInstSvcLine) {
			if (null != oInstSvcLine.getServiceKey()
					&& oInstSvcLine.getServiceKey().equalsIgnoreCase(
							aEntityAdtlId.getInstServiceKey())
					&& null != oInstSvcLine.getSv203lnItmChrg()) {
				lineItemChrgAmt = oInstSvcLine.getSv203lnItmChrg();
			}
		}
		return lineItemChrgAmt;
	}

	/**
	 * 
	 * @param aEntityAdtlId
	 * @param strSVC1
	 * @param lineItemChrgAmt
	 */
	final String buildInstSVC1(EntityAdtlId aEntityAdtlId) {
		StringBuffer strSVC01 = new StringBuffer();
		for (InstSvcLine oInstSvcLine : listInstSvcLine) {
			if (null != oInstSvcLine.getServiceKey()
					&& oInstSvcLine.getServiceKey().equalsIgnoreCase(
							aEntityAdtlId.getInstServiceKey())) {
				if (null != oInstSvcLine.getSv202svcIdQual()
						&& oInstSvcLine.getSv202svcIdQual().length() > 0) {
					strSVC01.append(oInstSvcLine.getSv202svcIdQual());
				}
				if (null != oInstSvcLine.getSv202procCd()
						&& oInstSvcLine.getSv202procCd().length() > 0) {
					strSVC01.append(":");
					strSVC01.append(oInstSvcLine.getSv202procCd());
				}
				if (null != oInstSvcLine.getSv202procMod1()
						&& oInstSvcLine.getSv202procMod1().length() > 0) {
					strSVC01.append(":");
					strSVC01.append(oInstSvcLine.getSv202procMod1());
				}
				if (null != oInstSvcLine.getSv202procMod2()
						&& oInstSvcLine.getSv202procMod2().length() > 0) {
					strSVC01.append(":");
					strSVC01.append(oInstSvcLine.getSv202procMod2());
				}
				if (null != oInstSvcLine.getSv202procMod3()
						&& oInstSvcLine.getSv202procMod3().length() > 0) {
					strSVC01.append(":");
					strSVC01.append(oInstSvcLine.getSv202procMod3());
				}
				if (null != oInstSvcLine.getSv202procMod4()
						&& oInstSvcLine.getSv202procMod4().length() > 0) {
					strSVC01.append(":");
					strSVC01.append(oInstSvcLine.getSv202procMod4());
				}
			}
		}
		return strSVC01.toString();
	}

	/**
	 * 
	 * @param oEntityAdtlId
	 * @param lineAmt
	 */
	final BigDecimal buildInstSTC(EntityAdtlId oEntityAdtlId) {
		BigDecimal lineAmt = null;
		for (InstSvcLine oInstSvcLine : listInstSvcLine) {
			if (null != oInstSvcLine.getServiceKey()
					&& oInstSvcLine.getServiceKey().equalsIgnoreCase(
							oEntityAdtlId.getInstServiceKey())) {
				lineAmt = oInstSvcLine.getSv203lnItmChrg();
			}
		}
		return lineAmt;
	}

	/**
	 * 
	 * @param oEntityAdtlId
	 * @param lineAmt
	 */
	final BigDecimal buildPrfsnSTC(EntityAdtlId oEntityAdtlId) {
		BigDecimal lineAmt = null;
		for (PrfsnSvcLine oPrfsnSvcLine : listPrfsnSvcLine) {
			if (null != oPrfsnSvcLine.getServiceKey()
					&& oPrfsnSvcLine.getServiceKey().equalsIgnoreCase(
							oEntityAdtlId.getPrfsnServiceKey())) {
				lineAmt = oPrfsnSvcLine.getSv102lineItmChrg();
			}
		}
		return lineAmt;
	}

	/**
	 * 
	 * @param oEntityAdtlId
	 * @param lineAmt
	 */
	final BigDecimal buildDentalSTC(EntityAdtlId oEntityAdtlId) {
		BigDecimal lineAmt = null;
		for (DentalSvcLine oDentalSvcLine : listDentalSvcLine) {
			if (null != oDentalSvcLine.getServiceKey()
					&& oDentalSvcLine.getServiceKey().equalsIgnoreCase(
							oEntityAdtlId.getDentalServiceKey())) {
				lineAmt = oDentalSvcLine.getSv302lnItmChrg();
			}
		}
		return lineAmt;
	}

	/**
	 * 
	 * @param oEntityAdtlId
	 * @param oClaimType
	 */
	final void createRejSTC(EntityAdtlId oEntityAdtlId, String oClaimType) {
		LOGGER.debug("Begin Creating Rej STC");
		BigDecimal lineAmt = null;
		if (INST_SVC_LINE.equalsIgnoreCase(reposClaim.getClaimType())
				&& null != listInstSvcLine) {
			lineAmt = buildInstSTC(oEntityAdtlId);
		}
		if (PRFSN_SVC_LINE.equalsIgnoreCase(reposClaim.getClaimType())
				&& null != listPrfsnSvcLine) {
			lineAmt = buildPrfsnSTC(oEntityAdtlId);
		}
		if (DENTAL_SVC_LINE.equalsIgnoreCase(reposClaim.getClaimType())
				&& null != listDentalSvcLine) {
			lineAmt = buildDentalSTC(oEntityAdtlId);
		}
		StringBuffer strSTC = new StringBuffer();
		strSTC.append("STC");
		dataElementSeparator(strSTC);
		strSTC.append(this.strSTC01);
		dataElementSeparator(strSTC);
		strSTC.append(getCreatedDateyyyyMMdd());
		dataElementSeparator(strSTC);
		strSTC.append("U");
		if (null != lineAmt) {
			dataElementSeparator(strSTC);
			strSTC.append(lineAmt);
		}
		segmentTerminator(strSTC);
		strSTC.append(CRLF);
		vCsFile.print(strSTC);
		vCsFile.flush();
		strSTC = null;
		cnt++;
		LOGGER.debug("End Creating Rej STC");
	}

	/**
	 * 
	 * @param oEntityAdtlId
	 * @param oClaimType
	 */
	final void createRejREF(EntityAdtlId oEntityAdtlId, String oClaimType) {
		LOGGER.debug("Begin Creating Rej REF");
		StringBuffer strREF = new StringBuffer();
		strREF.append("REF");
		dataElementSeparator(strREF);
		strREF.append("FJ");
		dataElementSeparator(strREF);
		strREF.append(oEntityAdtlId.getRef02scndId());
		segmentTerminator(strREF);
		strREF.append(CRLF);
		vCsFile.print(strREF);
		vCsFile.flush();
		strREF = null;
		cnt++;
		LOGGER.debug("End Creating Rej REF");
	}

	/**
	 * 
	 * @param oEntityAdtlId
	 * @param oClaimType
	 */
	final void createRejDTP(EntityAdtlId oEntityAdtlId, String oClaimType) {
		LOGGER.debug("Begin Creating Rej DTP");
		String dtp01 = "";
		String dtp02 = "";
		String dtp03 = "";

		for (ClaimDate aClaimDate : listClaimDate) {
			if (null != aClaimDate.getInstSvcLineKey()
					&& aClaimDate.getInstSvcLineKey().equalsIgnoreCase(
							oEntityAdtlId.getInstServiceKey())) {
				dtp01 = aClaimDate.getDtp01dttmQual();
				dtp01 = aClaimDate.getDtp02dttmFmtQual();
				dtp03 = aClaimDate.getDtp03dtFld();
			}

			if (null != aClaimDate.getPrfsnSvcLineKey()
					&& aClaimDate.getPrfsnSvcLineKey().equalsIgnoreCase(
							oEntityAdtlId.getPrfsnServiceKey())) {
				dtp01 = aClaimDate.getDtp01dttmQual();
				dtp01 = aClaimDate.getDtp02dttmFmtQual();
				dtp03 = aClaimDate.getDtp03dtFld();
			}

			if (null != aClaimDate.getDentalSvcLineKey()
					&& aClaimDate.getDentalSvcLineKey().equalsIgnoreCase(
							oEntityAdtlId.getDentalServiceKey())) {
				dtp01 = aClaimDate.getDtp01dttmQual();
				dtp01 = aClaimDate.getDtp02dttmFmtQual();
				dtp03 = aClaimDate.getDtp03dtFld();
			}
		}
		StringBuffer strDTP = new StringBuffer();
		strDTP.append("DTP");
		dataElementSeparator(strDTP);
		strDTP.append("472");
		dataElementSeparator(strDTP);
		strDTP.append(dtp01);
		dataElementSeparator(strDTP);
		strDTP.append(dtp02);
		dataElementSeparator(strDTP);
		strDTP.append(dtp03);
		segmentTerminator(strDTP);
		strDTP.append(CRLF);
		vCsFile.print(strDTP);
		vCsFile.flush();
		strDTP = null;
		cnt++;
		LOGGER.debug("End  Creating Rej DTP");
	}

	/**
	 * Service line level status...
	 */
	protected void createSTC3() {
		LOGGER.debug("Begin Creating STC3");
		boolean isRejected = false;
		setRejectClaimDate();
		getRejectClaim();
		StringBuffer strSTC = new StringBuffer();
		strSTC.append("STC");
		dataElementSeparator(strSTC);
		if (null != reposClaim.getStatusCode()
				&& reposClaim.getStatusCode().equals(REJECTED)) {
			isRejected = true;
			if (null != strSTC01 && strSTC01.length() > 0) {
				strSTC.append(strSTC01);
				dataElementSeparator(strSTC);
				strSTC.append(getCreatedDateyyyyMMdd());
				dataElementSeparator(strSTC);
				strSTC.append("U");
				if (null != strSTC10 && strSTC10.length() > 0) {
					dataElementSeparator(strSTC);
					dataElementSeparator(strSTC);
					dataElementSeparator(strSTC);
					dataElementSeparator(strSTC);
					dataElementSeparator(strSTC);
					dataElementSeparator(strSTC);
					dataElementSeparator(strSTC);
					strSTC.append(strSTC10);
					if (null != strSTC11 && strSTC11.length() > 0) {
						dataElementSeparator(strSTC);
						strSTC.append(strSTC11);
					}
				}
				segmentTerminator(strSTC);
			} else {
				strSTC.append("A3:21");
				dataElementSeparator(strSTC);
				strSTC.append(getCreatedDateyyyyMMdd());
				dataElementSeparator(strSTC);
				strSTC.append("U");
				dataElementSeparator(strSTC);
				if (null != reposClaim.getClm02clmChrgAmt()) {
					strSTC.append(reposClaim.getClm02clmChrgAmt());
				}
				segmentTerminator(strSTC);
			}
		} else {
			strSTC.append("A2:20");
			dataElementSeparator(strSTC);
			strSTC.append(getCreatedDateyyyyMMdd());
			dataElementSeparator(strSTC);
			strSTC.append("WQ");
			dataElementSeparator(strSTC);
			if (null != reposClaim.getClm02clmChrgAmt()) {
				strSTC.append(reposClaim.getClm02clmChrgAmt());
			}
			segmentTerminator(strSTC);
		}
		strSTC.append(CRLF);
		vCsFile.print(strSTC);
		vCsFile.flush();
		strSTC = null;
		cnt++;
		LOGGER.debug("End Creating STC2");
	}

	/**
	 * 
	 */
	protected void createReceiverREF() {
		LOGGER.debug("Begin Creating Receiver REF");
		if (null != receiverStatus && null != receiverStatus.getRef02scndId()) {
			StringBuffer strREF = new StringBuffer();
			strREF.append("REF");
			dataElementSeparator(strREF);
			strREF.append("FJ");
			dataElementSeparator(strREF);
			if (null != serviceLineStatus) {
				strREF.append(receiverStatus.getRef02scndId());
			}
			segmentTerminator(strREF);
			strREF.append(CRLF);
			vCsFile.print(strREF);
			vCsFile.flush();
			strREF = null;
			cnt++;
		}
		LOGGER.debug("End Creating Receiver REF");
	}

	/**
	 * 
	 */
	protected void createBillingREF() {
		LOGGER.debug("Begin Creating REF");
		if (null != billingProviderStatus
				&& null != billingProviderStatus.getRef02scndId()) {
			StringBuffer strREF = new StringBuffer();
			strREF.append("REF");
			dataElementSeparator(strREF);
			strREF.append("D9");
			dataElementSeparator(strREF);
			strREF.append(billingProviderStatus.getRef02scndId());
			segmentTerminator(strREF);
			strREF.append(CRLF);
			vCsFile.print(strREF);
			vCsFile.flush();
			strREF = null;
			cnt++;
		}
		LOGGER.debug("End Creating REF");
	}

	/**
	 * 
	 */
	protected void createClaimREF() {
		LOGGER.debug("Begin Creating Claim Level REF");
		StringBuffer strREF = new StringBuffer();
		strREF.append("REF");
		dataElementSeparator(strREF);
		strREF.append("BLT");
		dataElementSeparator(strREF);
		strREF.append(reposClaim.getClm05fclyTypeCd()
				+ reposClaim.getClm05clmFrqCd());
		segmentTerminator(strREF);
		strREF.append(CRLF);
		vCsFile.print(strREF);
		vCsFile.flush();
		strREF = null;
		cnt++;
		LOGGER.debug("End Creating Claim Level REF");
	}

	/**
	 * 
	 */
	protected void createDTP() {
		LOGGER.debug("Begin Creating DTP");
		setClaimDate();
		StringBuffer strDTP = new StringBuffer();
		strDTP.append("DTP");
		dataElementSeparator(strDTP);
		strDTP.append("472");
		if (null != oClaimDt) {
			dataElementSeparator(strDTP);
			strDTP.append(oClaimDt.getDtp02dttmFmtQual());
			dataElementSeparator(strDTP);
			strDTP.append(oClaimDt.getDtp03dtFld());
		}
		segmentTerminator(strDTP);
		strDTP.append(CRLF);
		vCsFile.print(strDTP);
		vCsFile.flush();
		strDTP = null;
		cnt++;
		LOGGER.debug("End Creating DTP");
	}

	/**
	 * 
	 */
	protected void createSE() {
		LOGGER.debug("Begin Creating SE");
		StringBuffer strSE = new StringBuffer();
		strSE.append("SE");
		dataElementSeparator(strSE);
		cnt++;
		strSE.append(cnt);
		dataElementSeparator(strSE);
		strSE.append(this.reposClaim.getSt02txnCtlNbr());
		segmentTerminator(strSE);
		strSE.append(CRLF);
		vCsFile.print(strSE);
		vCsFile.flush();
		strSE = null;
		LOGGER.debug("End Creating SE");
	}

	/**
	 * 
	 */
	protected void createGEBatch() {
		LOGGER.debug("Begin Creating GE");
		StringBuffer strGE = new StringBuffer();
		strGE.append("GE");
		dataElementSeparator(strGE);
		strGE.append("1");
		dataElementSeparator(strGE);
		strGE.append(oFunctionalGroup.getGs06grpCtlNbr());
		segmentTerminator(strGE);
		strGE.append(CRLF);
		vCsFile.print(strGE);
		vCsFile.flush();
		strGE = null;
		LOGGER.debug("End Creating GE");
	}

	/**
	 * 
	 */
	protected void createIEABatch() {
		LOGGER.debug("Begin Creating IEA");
		StringBuffer strIEA = new StringBuffer();
		strIEA.append("IEA");
		dataElementSeparator(strIEA);
		strIEA.append("1");
		dataElementSeparator(strIEA);
		strIEA.append(getInterChangeCtrlNumber());
		segmentTerminator(strIEA);
		strIEA.append(CRLF);
		vCsFile.print(strIEA);
		vCsFile.flush();
		strIEA = null;
		LOGGER.debug("End Creating IEA");
	}

	/**
	 * 
	 */
	private void setBHT() {
		LOGGER.debug("Begin extract BHT Information");
		Query q = em
				.createQuery("select ts from gov.va.med.domain.erepos.TxnSet ts where ts.id.fileNumber = :fileNumber and ts.se02txnCtlNbr = :txnCtlNbr");
		q.setParameter("fileNumber", reposClaim.getFileNumber());
		q.setParameter("txnCtlNbr", reposClaim.getSt02txnCtlNbr());
		List<TxnSet> txnSetList = q.getResultList();
		if (null != txnSetList && txnSetList.size() > 0) {
			oTxnSet = txnSetList.get(0);
		}
		LOGGER.debug("End extract BHT Information");
	}

	/**
	 * 
	 * @return PatientInfo
	 */
	private PatientInfo getPatientInfo() {
		LOGGER.debug("Begin extract Patient Information");
		String sql = "select * from PATIENT_INFO where PATIENT_INFO_KEY=:patientInfoKey";
		Query q = em.createNativeQuery(sql);
		q.setParameter("patientInfoKey", reposClaim.getPatientInfo());
		List<PatientInfo> patientInfoList = q.getResultList();

		if (null != patientInfoList && patientInfoList.size() > 0) {
			oPatientInfo = patientInfoList.get(0);
		}
		LOGGER.debug("End extract Patient Information");
		return oPatientInfo;
	}

	/**
	 * 
	 * @return String
	 */
	private String getSenderId() {
		LOGGER.debug("Begin extract Sender ID Information");
		String strSenderId = "";
		if (reposClaim != null) {
			strSenderId = reposClaim.getSenderId();
			if (strSenderId != null && strSenderId.length() < 15) {
				for (int i = strSenderId.length(); i < 15; i++) {
					strSenderId = strSenderId.concat(" ");
				}
			}
		}
		LOGGER.debug("End extract sender ID Information");
		return strSenderId;
	}

	/**
	 * 
	 * @return String
	 */
	private String getReceiverId() {
		LOGGER.debug("Begin extract Receiver ID Information");
		String strReceiverId = "";
		if (null != reposClaim) {
			strReceiverId = reposClaim.getReceiverId();
			if (null != strReceiverId && strReceiverId.length() < 15) {
				for (int i = strReceiverId.length(); i < 15; i++) {
					strReceiverId = strReceiverId.concat(" ");
				}
			}
		}
		LOGGER.debug("End extract Receiver ID Information");
		return strReceiverId;
	}

	/**
	 * 
	 */
	final void setClaimDate() {
		LOGGER.debug("Begin extract Claim Date Information");
		try {
			String sql = "SELECT * FROM CLAIM_DT WHERE CLAIM_KEY= ? AND DTP01DTTM_QUAL= ?";
			pStatement = conn.prepareStatement(sql);
			pStatement.setString(1, reposClaim.getClaimKey());
			pStatement.setString(2, "472");
			ResultSet rs = pStatement.executeQuery();
			if (null != rs) {
				oClaimDt = new ClaimDt();
				while (rs.next()) {
					oClaimDt.setDtp02dttmFmtQual(rs.getString(
							"DTP02DTTM_FMT_QUAL").trim());
					oClaimDt.setDtp03dtFld(rs.getString("DTP03DT_FLD"));
				}
				rs.close();
			}
			if (null != pStatement) {
				pStatement.close();
			}
		} catch (Exception exp) {
			exp.printStackTrace();
		}
		LOGGER.debug("End extract Claim Date Information");
	}

	/**
	 * 
	 * @return EntityName
	 */
	final void setEntityInfo() {
		LOGGER.debug("Begin extract Entity Name Information");
		List<EntityName> entityNames = getEntityInfo();
		if (null != entityNames && (entityNames.size() > 0)) {
			if (null != listEntityName) {
				listEntityName.clear();
			} else {
				listEntityName = new ArrayList<EntityName>();
			}
			for (EntityName anEntity : entityNames) {
				if (anEntity.getLoopId().equalsIgnoreCase(("1000A"))) {
					senderInfo = anEntity;
					listEntityName.add(senderInfo);
				} else if (anEntity.getLoopId().equalsIgnoreCase(("1000B"))) {
					receiverInfo = anEntity;
					listEntityName.add(receiverInfo);
				} else if (anEntity.getLoopId().equalsIgnoreCase("2010BA")) {
					oPatient = anEntity;
					listEntityName.add(oPatient);
				} else if (anEntity.getLoopId().equalsIgnoreCase("2010AA")) {
					billingProviderInfo = anEntity;
					listEntityName.add(billingProviderInfo);
				}
			}
		} else {
			LOGGER.debug(
					"Did not get entity names from claim key: {} note:it may not be required",
					new Object[] { reposClaim.getClaimKey() });
		}
		LOGGER.debug("End extract Entity Name Information");
	}

	/**
	 * 
	 * @return List
	 */
	final List<EntityName> getEntityInfo() {
		String qstr = "select * from E_REPOS.Entity_Name e where e.claim_Key = ?";
		EntityName aName = null;
		List<EntityName> listENames = null;
		try {
			pStatement = conn.prepareStatement(qstr);
			pStatement.setString(1, reposClaim.getClaimKey());
			rs = pStatement.executeQuery();
			if (null != rs) {
				listENames = new ArrayList<EntityName>();
				while (rs.next()) {
					aName = new EntityName();
					aName.setClaimKey(rs.getString("CLAIM_KEY"));
					aName.setNm109billPrvdId(rs.getString("NM109BILL_PRVD_ID"));
					aName.setNm109sbsrId(rs.getString("NM109SBSR_ID"));
					aName.setNm109ptntId(rs.getString("NM109PTNT_ID"));
					aName.setInstSvcLineKey(rs.getString("INST_SERVICE_KEY"));
					aName.setPrfsnSvcLineKey(rs.getString("PRFSN_SERVICE_KEY"));
					aName.setDentalSvcLineKey(rs
							.getString("DENTAL_SERVICE_KEY"));
					aName.setLoopId(rs.getString("LOOP_ID"));
					aName.setTxType(rs.getString("TX_TYPE"));
					aName.setNm101entyIdCd(rs.getString("NM101ENTY_ID_CD"));
					if (null != rs.getString("NM102ENTY_QUAL")
							&& rs.getString("NM102ENTY_QUAL").length() > 0) {
						aName.setNm102entyQual(rs.getString("NM102ENTY_QUAL")
								.charAt(0));
					}
					aName.setNm103lastNm(rs.getString("NM103LAST_NM"));
					aName.setNm104fstNm(rs.getString("NM104FST_NM"));
					aName.setNm105midNm(rs.getString("NM105MID_NM"));
					aName.setNm107nmSfx(rs.getString("NM107NM_SFX"));
					aName.setNm108idCdQual(rs.getString("NM108ID_CD_QUAL"));
					aName.setNm109idCd(rs.getString("NM109ID_CD"));
					aName.setNm112lastNmOrganizNm(rs
							.getString("NM112LAST_NM_ORGANIZ_NM"));
					aName.setNm106nmPfx(rs.getString("NM106NM_PFX"));
					aName.setNm110entyRelCd(rs.getString("NM110ENTY_REL_CD"));
					aName.setNm111entyIdCd(rs.getString("NM111ENTY_ID_CD"));
					aName.setHrchlLevelKey(rs.getString("HRCHL_LEVEL_KEY"));
					listENames.add(aName);
				}
			}
		} catch (SQLException sqlExp) {
			sqlExp.printStackTrace();
		}
		return listENames;
	}

	/**
	 * 
	 */
	final void getRejectClaim() {
		LOGGER.debug("Begin getRejectClaim Information");
		String strQuery = "select e from eRejectClaim e where e.ediClaimKey = :ediClaimKey";
		Query q = em.createQuery(strQuery);
		q.setParameter("ediClaimKey", reposClaim.getClaimKey());
		List<RejectClaim> rejectClaims = q.getResultList();
		if (null != rejectClaims && rejectClaims.size() > 0) {
			oRejectClaim = rejectClaims.get(0);
			setSTCStatClaimCodes();
		}
		LOGGER.debug("End getRejectClaim Information");
	}

	/**
	 * 
	 */
	final void setSTCStatClaimCodes() {
		if (null != oRejectClaim && null != oRejectClaim.getRejectReasonCodes()
				&& null != oRejectClaim.getRejectReasonCodes().getRejectCode()) {
			String strRejectCode = oRejectClaim.getRejectReasonCodes()
					.getRejectCode();
			if (null != strRejectCode) {
				String results[] = strRejectCode.split(";");
				if (results.length == 1) {
					strSTC01 = results[0];
				}

				if (results.length == 2) {
					strSTC01 = results[0];
					strSTC10 = results[1];
				}

				if (results.length == 3) {
					strSTC01 = results[0];
					strSTC10 = results[1];
					strSTC11 = results[2];
				}
			}
		}
	}

	/**
	 * 
	 */
	final void setEreposClaim(String fileNbr) {
		LOGGER.debug("Begin extract E_REPOS CLAIM Information");
		// String sqlSelectAll =
		// "SELECT e.*   FROM fpps_owner.claims c , e_repos.claim e WHERE e.claim_key = c.edi_claim_key and e.CLAIM_KEY not in (select a.CLAIM_KEY from e_repos.claim_277ca a) and rownum < 10";
		String sqlSelectAll = "SELECT e.* FROM e_repos.claim e WHERE  e.FILE_NUMBER = '"
				+ fileNbr + "'";
		org.hibernate.Query claimQuery = oSession.createSQLQuery(sqlSelectAll)
				.addEntity(gov.va.med.domain.erepos.Claim.class);
		claims = claimQuery.scroll(ScrollMode.FORWARD_ONLY);
		LOGGER.debug("End extract FPPS_OWNER and E_REPOS CLAIM Information");
	}

	/**
	 * 
	 * @param beginDate
	 * @param endDate
	 * @return List
	 * @throws SQLException
	 */
	final List<String> getBatchIDs(Date beginDate, Date endDate) {
		LOGGER.debug("Begin extract Batch IDs between the dates..");
		List<String> lString = null;
		String qstr = "select c.FILE_NUMBER from E_REPOS.CLAIM c where c.STATUS_CODE IN ('277U_ACCPT_SENT','277U_REJ_SENT') and c.DATE_CREATED between ? and ?";
		try {
			pStatement = conn.prepareStatement(qstr);
			pStatement.setDate(1, (java.sql.Date) beginDate);
			ResultSet rs = pStatement.executeQuery();
			if (null != rs) {
				lString = new ArrayList<String>();
				while (rs.next()) {
					lString.add(rs.getString("FILE_NUMBER"));
				}
			}
		} catch (SQLException sqlExp) {
			LOGGER.error("--- Unable to execute query for getBatchIDs() ---",
					sqlExp.getMessage());
		}
		LOGGER.debug("End extract Batch IDs between the dates..");
		return lString;
	}

	/**
	 * 
	 */
	private void setFunctionalGroup() {
		LOGGER.debug("Begin extract Functional Group Information");
		try {
			String sql = "select * from FUNCTIONAL_GROUP where FILE_NUMBER= ?";
			pStatement = conn.prepareStatement(sql);
			pStatement.setString(1, reposClaim.getFileNumber());
			ResultSet rs = pStatement.executeQuery();
			if (null != rs) {
				oFunctionalGroup = new FunctionalGroup();
				while (rs.next()) {
					oFunctionalGroup.setFileNumber(rs.getString("FILE_NUMBER"));
					oFunctionalGroup.setTxType(rs.getString("TX_TYPE"));
					oFunctionalGroup.setGe01nbrTranSets(rs
							.getString("GS01FCTL_ID_CD"));
					oFunctionalGroup.setGe02grpCtlNbr(rs
							.getString("GS02APP_SND_CD"));
					oFunctionalGroup.setGs03appRcvCd(rs
							.getString("GS03APP_RCV_CD"));
					oFunctionalGroup.setGs04creDt(rs.getString("GS04CRE_DT"));
					oFunctionalGroup.setGs05creTm(rs.getString("GS05CRE_TM"));
					oFunctionalGroup.setGs06grpCtlNbr(rs
							.getString("GS06GRP_CTL_NBR"));
					oFunctionalGroup.setGs07respAgcyCd(rs
							.getString("GS07RESP_AGCY_CD"));
					oFunctionalGroup.setGs08verRlsIndId(rs
							.getString("GS08VER_RLS_IND_ID"));
					oFunctionalGroup.setGe01nbrTranSets(rs
							.getString("GE01NBR_TRAN_SETS"));
					oFunctionalGroup.setGe02grpCtlNbr(rs
							.getString("GE02GRP_CTL_NBR"));
					oFunctionalGroup.setCreatedBy(rs.getString("CREATED_BY"));
					oFunctionalGroup.setModifiedBy(rs.getString("MODIFIED_BY"));
				}
				rs.close();
			}
			if (null != pStatement) {
				pStatement.close();
			}
		} catch (Exception exp) {
			exp.printStackTrace();
		}
		LOGGER.debug("End extract Functional Group Information");
	}

	/**
	 * 
	 */
	final void persist277CAStatus() {
		String sqlInsert = "";
		String strPrcCd = "";
		String strRevCd = "";
		String strDtFld = "";
		String strStatus = "";
		BigDecimal bdItmChrg = null;
		BigDecimal bdUnitCnt = null;
		try {
			String checkRecSql = "select * from E_REPOS.CLAIM_277CA_STC where CLAIM_KEY = ?";
			pStatement = conn.prepareStatement(checkRecSql);
			pStatement.setString(1, reposClaim.getClaimKey());
			ResultSet rs = pStatement.executeQuery();
			if (null == rs || !rs.next()) {
				pStatement = null;
				sqlInsert = "insert into E_REPOS.CLAIM_277CA_STC (\"CLAIM_KEY\", \"FILE_NUMBER\", \"LOOPID_837\", \"LICN\", \"CHARGE_AMT\", \"COMP_MED_PROC_ID\", \"REV_CODE\", \"SERVICE_UNITS\", \"DTP03SVC_LINE_DTE\", \"STC_STAT_LINE\", \"STC_DATE_LINE\", \"STC_ACTION_CODE_LINE\", \"STC_CHARGE_AMT_LINE\" ) values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
				pStatement = conn.prepareStatement(sqlInsert);
				System.out.println("Entity Additional IDs count #"
						+ listEntityAdtlId.size());
				for (EntityAdtlId anEntityAdtlId : listEntityAdtlId) {
					pStatement.setString(1, anEntityAdtlId.getClaimKey());
					pStatement.setString(2, anEntityAdtlId.getFileNumber());
					pStatement.setString(3, anEntityAdtlId.getLoopId());
					pStatement.setString(4, anEntityAdtlId.getRef02scndId());
					if (INST_SVC_LINE.equalsIgnoreCase(reposClaim
							.getClaimType())
							&& null != anEntityAdtlId.getInstServiceKey()) {
						for (InstSvcLine anInst : listInstSvcLine) {
							if (anInst.getServiceKey().equalsIgnoreCase(
									anEntityAdtlId.getInstServiceKey())) {
								bdItmChrg = anInst.getSv203lnItmChrg();
								strPrcCd = createProcId(
										anInst.getSv202svcIdQual(),
										anInst.getSv202procCd(),
										anInst.getSv202procMod1(),
										anInst.getSv202procMod2(),
										anInst.getSv202procMod3(),
										anInst.getSv202procMod4());
								strRevCd = anInst.getSv201svcLnRevCd();
								bdUnitCnt = anInst.getSv205svcUnitCnt();
							}
						}

						for (ClaimDate anClaimDt : listClaimDate) {
							if (null != anClaimDt.getInstSvcLineKey()
									&& anClaimDt
											.getInstSvcLineKey()
											.equalsIgnoreCase(
													anEntityAdtlId
															.getInstServiceKey())) {
								strDtFld = anClaimDt.getDtp03dtFld();

							}
						}
					}
					if (PRFSN_SVC_LINE.equalsIgnoreCase(reposClaim
							.getClaimType())
							&& null != anEntityAdtlId.getPrfsnServiceKey()) {
						for (PrfsnSvcLine anPrfsn : listPrfsnSvcLine) {
							if (anPrfsn.getServiceKey().equalsIgnoreCase(
									anEntityAdtlId.getPrfsnServiceKey())) {
								bdItmChrg = anPrfsn.getSv102lineItmChrg();
								strPrcCd = createProcId(
										anPrfsn.getSv101procCdQual(),
										anPrfsn.getSv101procCd(),
										anPrfsn.getSv101procMod1(),
										anPrfsn.getSv101procMod2(),
										anPrfsn.getSv101procMod3(),
										anPrfsn.getSv101procMod4());
								bdUnitCnt = anPrfsn.getSv104svcUnitCnt();
							}
						}

						for (ClaimDate anClaimDt : listClaimDate) {
							if (anClaimDt
									.getPrfsnSvcLineKey()
									.equalsIgnoreCase(
											anEntityAdtlId.getPrfsnServiceKey())) {
								strDtFld = anClaimDt.getDtp03dtFld();
							}
						}
					}

					if (DENTAL_SVC_LINE.equalsIgnoreCase(reposClaim
							.getClaimType())
							&& null != anEntityAdtlId.getDentalServiceKey()) {
						for (DentalSvcLine anDentalSvcLine : listDentalSvcLine) {
							if (anDentalSvcLine.getServiceKey()
									.equalsIgnoreCase(
											anEntityAdtlId
													.getDentalServiceKey())) {
								bdItmChrg = anDentalSvcLine.getSv302lnItmChrg();
								strPrcCd = createProcId(
										anDentalSvcLine.getSv301adaCdQual(),
										anDentalSvcLine.getSv301adaCd(),
										anDentalSvcLine.getSv301procMod1(),
										anDentalSvcLine.getSv301procMod2(),
										anDentalSvcLine.getSv301procMod3(),
										anDentalSvcLine.getSv301procMod4());
								bdUnitCnt = anDentalSvcLine.getSv306procCnt();
							}
						}

						for (ClaimDate anClaimDt : listClaimDate) {
							if (anClaimDt.getDentalSvcLineKey()
									.equalsIgnoreCase(
											anEntityAdtlId
													.getDentalServiceKey())) {
								strDtFld = anClaimDt.getDtp03dtFld();
							}
						}
					}

					if (null != bdItmChrg) {
						pStatement.setBigDecimal(5, bdItmChrg);
					} else {
						pStatement.setBigDecimal(5, BigDecimal.ZERO);
					}

					pStatement.setString(6, getCheckNull(strPrcCd));
					pStatement.setString(7, getCheckNull(strRevCd));
					if (null != bdUnitCnt) {
						pStatement.setBigDecimal(8, bdUnitCnt);
					} else {
						pStatement.setBigDecimal(8, BigDecimal.ZERO);
					}
					pStatement.setString(9, getCheckNull(strDtFld));
					if (reposClaim.getStatusCode().equalsIgnoreCase(REJECTED)) {
						pStatement.setString(10, strSTC01);
					} else {
						pStatement.setString(10, "");
					}
					pStatement.setString(11, getCreatedDateyyyyMMdd());
					if (ACCEPTED.equalsIgnoreCase(reposClaim.getStatusCode())) {
						strStatus = "WQ";
					} else {
						strStatus = "U";
					}
					pStatement.setString(12, getCheckNull(strStatus));
					pStatement.setBigDecimal(13,
							reposClaim.getClm02clmChrgAmt());
					pStatement.executeUpdate();
				}
			} else {
				sqlInsert = "update E_REPOS.CLAIM_277CA_STC set FILE_NUMBER = ?, LOOPID_837 = ?, LICN = ?, CHARGE_AMT = ?, COMP_MED_PROC_ID = ?, REV_CODE = ?, SERVICE_UNITS = ?, DTP03SVC_LINE_DTE = ?, STC_STAT_LINE = ?, STC_DATE_LINE = ?, STC_ACTION_CODE_LINE = ?, STC_CHARGE_AMT_LINE = ? where CLAIM_KEY = ?";
				pStatement = conn.prepareStatement(sqlInsert);
				for (EntityAdtlId anEntityAdtlId : listEntityAdtlId) {
					pStatement.setString(13, anEntityAdtlId.getClaimKey());
					pStatement.setString(1, anEntityAdtlId.getFileNumber());
					pStatement.setString(2, anEntityAdtlId.getLoopId());
					pStatement.setString(3, anEntityAdtlId.getRef02scndId());
					if (INST_SVC_LINE.equalsIgnoreCase(reposClaim
							.getClaimType())) {
						for (InstSvcLine anInst : listInstSvcLine) {
							if (anInst.getServiceKey().equalsIgnoreCase(
									anEntityAdtlId.getInstServiceKey())) {
								bdItmChrg = anInst.getSv203lnItmChrg();
								strPrcCd = createProcId(
										anInst.getSv202svcIdQual(),
										anInst.getSv202procCd(),
										anInst.getSv202procMod1(),
										anInst.getSv202procMod2(),
										anInst.getSv202procMod3(),
										anInst.getSv202procMod4());
								strRevCd = anInst.getSv201svcLnRevCd();
								bdUnitCnt = anInst.getSv205svcUnitCnt();
							}
						}

						for (ClaimDate anClaimDt : listClaimDate) {
							if (anClaimDt.getInstSvcLineKey().equalsIgnoreCase(
									anEntityAdtlId.getInstServiceKey())) {
								strDtFld = anClaimDt.getDtp03dtFld();
							}
						}
					}
					if (PRFSN_SVC_LINE.equalsIgnoreCase(reposClaim
							.getClaimType())) {
						for (PrfsnSvcLine anPrfsn : listPrfsnSvcLine) {
							if (anPrfsn.getServiceKey().equalsIgnoreCase(
									anEntityAdtlId.getPrfsnServiceKey())) {
								bdItmChrg = anPrfsn.getSv102lineItmChrg();
								strPrcCd = createProcId(
										anPrfsn.getSv101procCdQual(),
										anPrfsn.getSv101procCd(),
										anPrfsn.getSv101procMod1(),
										anPrfsn.getSv101procMod2(),
										anPrfsn.getSv101procMod3(),
										anPrfsn.getSv101procMod4());
								bdUnitCnt = anPrfsn.getSv104svcUnitCnt();
							}
						}

						for (ClaimDate anClaimDt : listClaimDate) {
							if (anClaimDt
									.getPrfsnSvcLineKey()
									.equalsIgnoreCase(
											anEntityAdtlId.getPrfsnServiceKey())) {
								strDtFld = anClaimDt.getDtp03dtFld();
							}
						}
					}

					if (DENTAL_SVC_LINE.equalsIgnoreCase(reposClaim
							.getClaimType())) {
						for (DentalSvcLine anDentalSvcLine : listDentalSvcLine) {
							if (anDentalSvcLine.getServiceKey()
									.equalsIgnoreCase(
											anEntityAdtlId
													.getDentalServiceKey())) {
								bdItmChrg = anDentalSvcLine.getSv302lnItmChrg();
								strPrcCd = createProcId(
										anDentalSvcLine.getSv301adaCdQual(),
										anDentalSvcLine.getSv301adaCd(),
										anDentalSvcLine.getSv301procMod1(),
										anDentalSvcLine.getSv301procMod2(),
										anDentalSvcLine.getSv301procMod3(),
										anDentalSvcLine.getSv301procMod4());
								bdUnitCnt = anDentalSvcLine.getSv306procCnt();
							}
						}

						for (ClaimDate anClaimDt : listClaimDate) {
							if (anClaimDt.getDentalSvcLineKey()
									.equalsIgnoreCase(
											anEntityAdtlId
													.getDentalServiceKey())) {
								strDtFld = anClaimDt.getDtp03dtFld();
							}
						}
					}
					if (null != bdItmChrg) {
						pStatement.setBigDecimal(4, bdItmChrg);
					} else {
						pStatement.setBigDecimal(4, BigDecimal.ZERO);
					}
					pStatement.setString(5, getCheckNull(strPrcCd));
					pStatement.setString(6, getCheckNull(strRevCd));
					if (null != bdUnitCnt) {
						pStatement.setBigDecimal(7, bdUnitCnt);
					} else {
						pStatement.setBigDecimal(7, BigDecimal.ZERO);
					}
					pStatement.setString(8, getCheckNull(strDtFld));
					pStatement.setString(9, getCheckNull(strSTC01));
					pStatement.setString(10, getCreatedDateyyyyMMdd());
					if (ACCEPTED.equalsIgnoreCase(reposClaim.getStatusCode())) {
						strStatus = "WQ";
					} else {
						strStatus = "U";
					}
					pStatement.setString(11, getCheckNull(strStatus));
					pStatement.setBigDecimal(12,
							reposClaim.getClm02clmChrgAmt());
					pStatement.executeUpdate();
				}
			}
		} catch (Exception exp) {
			exp.printStackTrace();
			LOGGER.error("Error During creation of Service Line Items...",
					exp.getMessage());
		}
	}

	final private String createProcId(String qual, String prcCd, String mod1,
			String mod2, String mod3, String mod4) {
		StringBuffer strModProc = new StringBuffer();
		strModProc.append(qual);
		if (null != prcCd && prcCd.length() > 0) {
			strModProc.append(":");
			strModProc.append(prcCd);
		}
		if (null != mod1 && mod1.length() > 0) {
			strModProc.append(":");
			strModProc.append(mod1);
		}
		if (null != mod2 && mod2.length() > 0) {
			strModProc.append(":");
			strModProc.append(mod2);
		}
		if (null != mod3 && mod3.length() > 0) {
			strModProc.append(":");
			strModProc.append(mod3);
		}
		if (null != mod4 && mod4.length() > 0) {
			strModProc.append(":");
			strModProc.append(mod4);
		}
		return strModProc.toString();
	}

	/**
	 * 
	 */
	final void persist277CA() {
		String sqlInsert = "";
		try {
			String checkRecSql = "select * from E_REPOS.CLAIM_277CA where CLAIM_KEY = ?";
			pStatement = conn.prepareStatement(checkRecSql);
			pStatement.setString(1, this.reposClaim.getClaimKey());
			ResultSet rs = pStatement.executeQuery();
			if (null == rs || !rs.next()) {
				sqlInsert = "insert into E_REPOS.CLAIM_277CA (\"CLAIM_KEY\", \"FILE_NUMBER\", \"PAYER_CLAIM_ID\", \"REF02SCND_ID\", \"DTP03CLAIM_SVCDT_FLD\", \"ST02TXN_CTL_NBR\", \"CLM01PT_ACCT_NBR\", \"CLM02CLM_CHRG_AMT\", \"REF02_BLT\", \"LOOPID_837\", \"NM101_ENTY_ID_CD\", \"NM102_ENTY_QUAL\", \"NM103LAST_NM\", \"NM104FST_NM\", \"NM105MID_NM\", \"NM108ID_CD_QUAL\", \"NM109ID_CD\", \"CLAIM_TYPE\") values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
				pStatement = conn.prepareStatement(sqlInsert);
				for (EntityName aName : listEntityName) {
					pStatement.setString(1, reposClaim.getClaimKey());
					pStatement.setString(2, reposClaim.getFileNumber());
					if (null != serviceLineStatus.getRef01idQlfr()
							&& serviceLineStatus.getRef01idQlfr()
									.equalsIgnoreCase("1k")) {
						pStatement.setString(3,
								serviceLineStatus.getRef02scndId());
					} else {
						pStatement.setString(3, "");
					}
					if (null != serviceLineStatus.getRef01idQlfr()
							&& serviceLineStatus.getRef01idQlfr()
									.equalsIgnoreCase("D9")) {
						pStatement.setString(4,
								serviceLineStatus.getRef02scndId());
					} else {
						pStatement.setString(4, "");
					}
					if (null != oClaimDt && null != oClaimDt.getDtp03dtFld()) {
						pStatement.setString(5, oClaimDt.getDtp03dtFld());
					} else {
						pStatement.setString(5, "");
					}

					pStatement.setString(6, reposClaim.getSt02txnCtlNbr());
					pStatement.setString(7, reposClaim.getClm01ptAcctNbr());
					pStatement
							.setBigDecimal(8, reposClaim.getClm02clmChrgAmt());
					pStatement.setString(9, reposClaim.getClm05fclyTypeCd()
							+ reposClaim.getClm05clmFrqCd());
					pStatement.setString(10, aName.getLoopId());
					pStatement.setString(11, aName.getNm101entyIdCd());
					if (null != aName.getNm102entyQual()) {
						pStatement.setString(12,
								String.valueOf(aName.getNm102entyQual()));
					}
					pStatement.setString(13, aName.getNm103lastNm());
					pStatement.setString(14, aName.getNm104fstNm());
					pStatement.setString(15, aName.getNm105midNm());
					pStatement.setString(16, aName.getNm108idCdQual());
					pStatement.setString(17, aName.getNm109billPrvdId());
					pStatement.setString(18, reposClaim.getClaimType());
					pStatement.executeUpdate();
				}
				pStatement.close();
			} else {
				sqlInsert = "update E_REPOS.CLAIM_277CA set FILE_NUMBER = ?, PAYER_CLAIM_ID = ?,  REF02SCND_ID = ?, DTP03CLAIM_SVCDT_FLD = ?, ST02TXN_CTL_NBR = ?, CLM01PT_ACCT_NBR = ?, CLM02CLM_CHRG_AMT = ?, REF02_BLT = ?, LOOPID_837 = ?, NM101_ENTY_ID_CD = ?, NM102_ENTY_QUAL = ?, NM103LAST_NM = ?, NM104FST_NM, NM105MID_NM = ?, NM108ID_CD_QUAL = ?, NM109ID_CD = ?, CLAIM_TYPE = ? where CLAIM_KEY = ?";
				for (EntityName aName : listEntityName) {
					pStatement = conn.prepareStatement(sqlInsert);
					pStatement.setString(18, reposClaim.getClaimKey());
					pStatement.setString(1, reposClaim.getFileNumber());
					if (null != serviceLineStatus.getRef01idQlfr()
							&& serviceLineStatus.getRef01idQlfr()
									.equalsIgnoreCase("1k")) {
						pStatement.setString(2,
								serviceLineStatus.getRef02scndId());
					} else {
						pStatement.setString(2, "");
					}
					if (null != serviceLineStatus.getRef01idQlfr()
							&& serviceLineStatus.getRef01idQlfr()
									.equalsIgnoreCase("D9")) {
						pStatement.setString(3,
								serviceLineStatus.getRef02scndId());
					} else {
						pStatement.setString(3, "");
					}
					pStatement.setString(4, oClaimDt.getDtp03dtFld());
					pStatement.setString(5, reposClaim.getSt02txnCtlNbr());
					pStatement.setString(6, reposClaim.getClm01ptAcctNbr());
					pStatement
							.setBigDecimal(7, reposClaim.getClm02clmChrgAmt());
					pStatement.setString(8, reposClaim.getClm05fclyTypeCd()
							+ reposClaim.getClm05clmFrqCd());
					pStatement.setString(9, aName.getNm101entyIdCd());
					if (null != aName.getNm102entyQual()) {
						pStatement.setString(10,
								String.valueOf(aName.getNm102entyQual()));
					}
					pStatement.setString(11, aName.getLoopId());
					pStatement.setString(12, aName.getNm103lastNm());
					pStatement.setString(13, aName.getNm104fstNm());
					pStatement.setString(14, aName.getNm105midNm());
					pStatement.setString(15, aName.getNm108idCdQual());
					pStatement.setString(16, aName.getNm109billPrvdId());
					pStatement.setString(17, reposClaim.getClaimType());
					pStatement.executeUpdate();
					pStatement.close();
				}
			}
			rs.close();
		} catch (Exception exp) {
			exp.printStackTrace();
		}
	}

	/**
	 * 
	 * @return String
	 */
	private static String getCreatedDateyyyyMMdd() {
		return new SimpleDateFormat("yyyyMMdd").format(new Date());
	}

	/**
	 * 
	 * @return String
	 */
	private static String getCreatedDateyyMMdd() {
		return new SimpleDateFormat("yyMMdd").format(new Date());
	}

	/**
	 * 
	 * @return String
	 */
	private static String getCreatedTimeHHmm() {
		return new SimpleDateFormat("HHmm").format(new Date());
	}

	/**
	 * 
	 * @return String
	 */
	private static String getCreatedTimeHHmmssSS() {
		return new SimpleDateFormat("HHmmssSS").format(new Date());
	}

	/**
	 * 
	 * @return String
	 */
	private String getInterChangeCtrlNumber() {
		return reposClaim.getSt02txnCtlNbr();
	}

	/**
	 * 
	 * @return String
	 */
	private String getGroupCtrlNumber() {
		String strGrpCtlNum = reposClaim.getSt02txnCtlNbr();
		strGrpCtlNum = Integer.valueOf(strGrpCtlNum).toString();
		return strGrpCtlNum;
	}

	/**
	 * Component Element Separator :
	 * 
	 * @param sb
	 */
	private static void componentElementSeparator(StringBuffer sb) {
		sb.append(COMPONENT_ELEMENT_SEPARATOR);
	}

	/**
	 * Data Element Separator *
	 * 
	 * @param sb
	 */
	private static void dataElementSeparator(StringBuffer sb) {
		sb.append(DATA_ELEMENT_SEPARATOR);
	}

	/**
	 * Segment Terminator ~
	 * 
	 * @param sb
	 */
	private static void segmentTerminator(StringBuffer sb) {
		sb.append(SEGMENT_TERMINATOR);
	}

	/**
	 * 
	 * @param sb
	 */
	private static void repetationSeperator(StringBuffer sb) {
		sb.append(REPETITION_SEPARATOR);
	}

	/**
	 * 
	 * @return String
	 */
	protected static String getNow() {
		Date dNow = new Date();
		SimpleDateFormat ft = new SimpleDateFormat("hh:mm:ss:ms");
		String out = ft.format(dNow);
		return out;
	}

	/**
	 * 
	 * @param strInString
	 * @return String
	 */
	private static String getCheckNull(String strInString) {
		String strOutString = "";
		if (null != strInString && strInString.length() > 0
				&& !"null".equalsIgnoreCase(strInString)) {
			strOutString = strInString.trim();
		}
		return strOutString;

	}
}
