/**
 * 
 */
package gov.va.med.hac.edi.extract.x214;

import gov.va.med.domain.erepos.ClaimDt;
import gov.va.med.domain.erepos.DentalSvcLine;
import gov.va.med.domain.erepos.InstSvcLine;
import gov.va.med.domain.erepos.PrfsnSvcLine;
import gov.va.med.domain.erepos.RejectClaim;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import javax.persistence.EntityManager;

import org.hibernate.ScrollableResults;
import org.hibernate.Session;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @author DNS
 *
 */
public class Build277CAStatusInformation {
	static final Logger LOGGER = LoggerFactory
			.getLogger(Build277CAStatusInformation.class);
	static final String ACCEPTED = "277U_ACCPT_SENT";
	final String REJECTED = "277U_REJ_SENT";
	final String ACCEPTED_WITH_ERRORS = "FPPS LOAD ERROR";
	final String PRFSN_SVC_LINE = "005010X222";
	final String INST_SVC_LINE = "005010X223";
	final String DENTAL_SVC_LINE = "005010X224";
	long claimKey;
	List<EntityAdtlId> listEntityAdtlId = null;
	EntityAdtlId receiverStatus = null; // 277CA LOOP ID 2200B, 837 LOOP ID
										// 1000B
	EntityAdtlId billingProviderStatus = null; // LOOP ID 2200C, 837 LOOP ID
												// 2010AA
	EntityAdtlId serviceLineStatus = null; // LOOP ID 2220D, 837 LOOP ID 2400
	EntityAdtlId claimLevelStatus = null; // LOOP ID 2200D, 837 LOOP ID 2300
	ClaimDt oClaimDt = null;
	RejectClaim oRejectClaim = null;
	List<InstSvcLine> listInstSvcLine = null;
	List<DentalSvcLine> listDentalSvcLine = null;
	List<PrfsnSvcLine> listPrfsnSvcLine = null;
	List<ClaimDate> listClaimDate = null;
	Session oSession = null;
	ScrollableResults claims = null;
	EntityManager em = null;
	Connection conn = null;
	PreparedStatement pStatement = null;
	ResultSet rs = null;
	gov.va.med.domain.erepos.Claim reposClaim = null;

	/**
	 * 
	 */
	final void setEntityAdtlId() {
		LOGGER.debug("Begin extract Entity Additional ID Information");
		List<EntityAdtlId> entityAdtlIdList = getEntityAdtlIdList();
		if (null != entityAdtlIdList && entityAdtlIdList.size() > 0) {
			if (null != listEntityAdtlId) {
				listEntityAdtlId.clear();
			} else {
				listEntityAdtlId = new ArrayList<EntityAdtlId>();
			}
			for (EntityAdtlId anEntityAdtlId : entityAdtlIdList) {
				if (anEntityAdtlId.getLoopId().equalsIgnoreCase("1000B")) {
					receiverStatus = anEntityAdtlId;
					listEntityAdtlId.add(receiverStatus);
				} else if (anEntityAdtlId.getLoopId()
						.equalsIgnoreCase("2010AA")) {
					billingProviderStatus = anEntityAdtlId;
					listEntityAdtlId.add(billingProviderStatus);
				} else if (anEntityAdtlId.getLoopId().equalsIgnoreCase("2400")) {
					serviceLineStatus = anEntityAdtlId;
					listEntityAdtlId.add(serviceLineStatus);
				} else if (anEntityAdtlId.getLoopId().equalsIgnoreCase("2300")) {
					claimLevelStatus = anEntityAdtlId;
					listEntityAdtlId.add(claimLevelStatus);
				}
			}
		}
		LOGGER.debug("End extract Entity Aditional ID Information");
	}

	/**
	 * 
	 * @return List
	 */
	final List<EntityAdtlId> getEntityAdtlIdList() {
		String sql = "select * from ENTITY_ADTL_ID e where e.CLAIM_KEY =:claimKey";
		List<EntityAdtlId> lEntityAdtlId = null;
		try {
			pStatement = conn.prepareStatement(sql);
			pStatement.setString(1, reposClaim.getClaimKey());
			rs = null;
			rs = pStatement.executeQuery();
			gov.va.med.hac.edi.extract.x214.EntityAdtlId oEntityAdtlId = null;			
			if (null != rs) {
				lEntityAdtlId = new ArrayList<EntityAdtlId>();
				while (rs.next()) {
					oEntityAdtlId = new EntityAdtlId();
					oEntityAdtlId.setRefSegKey(rs.getString("REF_SEG_KEY"));
					oEntityAdtlId.setClaimKey(rs.getString("CLAIM_KEY"));
					oEntityAdtlId.setFileNumber(rs.getString("FILE_NUMBER"));
					oEntityAdtlId.setNm109billPrvdId(rs
							.getString("NM109BILL_PRVD_ID"));
					oEntityAdtlId
							.setNm109sbsbsrId(rs.getString("NM109SBSR_ID"));
					oEntityAdtlId.setInstServiceKey(rs
							.getString("INST_SERVICE_KEY"));
					oEntityAdtlId.setPrfsnServiceKey(rs
							.getString("PRFSN_SERVICE_KEY"));
					oEntityAdtlId.setDentalServiceKey(rs
							.getString("DENTAL_SERVICE_KEY"));
					oEntityAdtlId.setClaimPymtInfoKey(rs
							.getString("CLAIM_PYMT_INFO_KEY"));
					oEntityAdtlId.setSvcPymtInfoKey(rs
							.getString("SVC_PYMT_INFO_KEY"));
					oEntityAdtlId.setSeqNbr(rs.getBigDecimal("SEQ_NBR"));
					oEntityAdtlId.setLoopId(rs.getString("LOOP_ID"));
					oEntityAdtlId.setTxType(rs.getString("TX_TYPE"));
					oEntityAdtlId.setRef01idQlfr(rs.getString("REF01ID_QLFR"));
					oEntityAdtlId.setRef02scndId(rs.getString("REF02SCND_ID"));
					oEntityAdtlId.setRef041refIdQlfr(rs
							.getString("REF04_1REF_ID_QLFR"));
					oEntityAdtlId.setRef042othrPyrPrmryId(rs
							.getString("REF04_2OTHR_PYR_PRMRY_ID"));
					oEntityAdtlId.setRef043refIdQlfr(rs
							.getString("REF04_3REF_ID_QLFR"));
					oEntityAdtlId.setRef044refId(rs.getString("REF04_4REF_ID"));
					oEntityAdtlId.setRef045refIdQlfr(rs
							.getString("REF04_5REF_ID_QLFR"));
					oEntityAdtlId.setRef046refId(rs.getString("REF04_6REF_ID"));
					oEntityAdtlId.setRef03desc(rs.getString("REF03DESC"));
					oEntityAdtlId.setHrchlLevelKey(rs
							.getString("HRCHL_LEVEL_KEY"));
					oEntityAdtlId.setSubscriberInfoKey(rs
							.getString("SUBSCRIBER_INFO_KEY"));
					lEntityAdtlId.add(oEntityAdtlId);
				}
				System.out.println("Initial size: "+ lEntityAdtlId.size());
			}
		} catch (SQLException sqlExp) {
			LOGGER.error("", sqlExp.getMessage());
		}
		return lEntityAdtlId;
	}

	/**
	 * 
	 */
	final void setRejectClaimDate() {
		LOGGER.debug("Begin creation of Rej Claim Date..");
		String sql = "select * from E_REPOS.CLAIM_DT dt where dt.CLAIM_KEY = ?";
		try {
			pStatement = conn.prepareStatement(sql);
			pStatement.setString(1, reposClaim.getClaimKey());
			rs = pStatement.executeQuery();
			if (null != rs) {
				ClaimDate aClaimDate = null;
				listClaimDate = new ArrayList<ClaimDate>();
				while (rs.next()) {
					aClaimDate = new ClaimDate();
					aClaimDate.setClaimKey(rs.getString("CLAIM_KEY"));
					aClaimDate.setClaimDtKey(rs.getString("CLAIM_DT_KEY"));
					aClaimDate.setDtp01dttmQual(rs.getString("DTP01DTTM_QUAL"));
					aClaimDate.setInstSvcLineKey(rs
							.getString("INST_SERVICE_KEY"));
					aClaimDate.setPrfsnSvcLineKey(rs
							.getString("PRFSN_SERVICE_KEY"));
					aClaimDate.setDentalSvcLineKey(rs
							.getString("DENTAL_SERVICE_KEY"));
					aClaimDate.setClaimPymtInfo(rs
							.getString("CLAIM_PYMT_INFO_KEY"));
					aClaimDate
							.setSvcPymtInfo(rs.getString("SVC_PYMT_INFO_KEY"));
					aClaimDate.setTxType(rs.getString("TX_TYPE"));
					aClaimDate.setSeqNbr(rs.getBigDecimal("SEQ_NBR"));
					aClaimDate.setDtp02dttmFmtQual(rs
							.getString("DTP02DTTM_FMT_QUAL"));
					aClaimDate.setDtp03dtFld(rs.getString("DTP03DT_FLD"));
					listClaimDate.add(aClaimDate);
				}
			}
		} catch (SQLException sqlExp) {
			LOGGER.error("Error on claim_dt table due to :",
					sqlExp.getMessage());
		}
		LOGGER.debug("End creation of Rej Claim Date..");
	}

	/**
	 * 
	 */
	final void setSVC() {
		String claimType = null;
		if (null != reposClaim && null != reposClaim.getClaimType()
				&& reposClaim.getClaimType().length() > 0) {
			claimType = reposClaim.getClaimType();
			if (PRFSN_SVC_LINE.equals(claimType)) {
				setPrfsnSvcLine();
			} else if (INST_SVC_LINE.equals(claimType)) {
				setInstSvcLine();
			} else if (DENTAL_SVC_LINE.equals(claimType)) {
				setDentalSvcLine();
			}
		}
	}

	/**
	 * @throws SQLException
	 * 
	 */
	final void setPrfsnSvcLine() {
		LOGGER.debug("Begin extract Prfsn Svc Line Information");
		String sql = "select * from PRFSN_SVC_LINE where CLAIM_KEY = :claimKey";
		try {
			pStatement = conn.prepareStatement(sql);
			pStatement.setString(1, reposClaim.getClaimKey());
			ResultSet rs = pStatement.executeQuery();
			if (null != rs) {
				PrfsnSvcLine oPrfsnSvcLine = null;
				listPrfsnSvcLine = new ArrayList<PrfsnSvcLine>();
				while (rs.next()) {
					oPrfsnSvcLine = new PrfsnSvcLine();
					oPrfsnSvcLine.setClaim(reposClaim);
					oPrfsnSvcLine.setServiceKey(rs.getString("SERVICE_KEY"));
					oPrfsnSvcLine.setLx01asgnLnItm(rs
							.getBigDecimal("LX01ASGN_LN_ITM"));
					oPrfsnSvcLine.setSv101procCdQual(rs
							.getString("SV101PROC_CD_QUAL"));
					oPrfsnSvcLine.setSv101procCd(rs.getString("SV101PROC_CD"));
					oPrfsnSvcLine.setSv101procMod1(rs
							.getString("SV101PROC_MOD1"));
					oPrfsnSvcLine.setSv101procMod2(rs
							.getString("SV101PROC_MOD2"));
					oPrfsnSvcLine.setSv101procMod3(rs
							.getString("SV101PROC_MOD3"));
					oPrfsnSvcLine.setSv101procMod4(rs
							.getString("SV101PROC_MOD4"));
					oPrfsnSvcLine.setSv102lineItmChrg(rs
							.getBigDecimal("SV102LINE_ITM_CHRG"));
					oPrfsnSvcLine.setSv103uomCd(rs.getString("SV103UOM_CD"));
					oPrfsnSvcLine.setSv104svcUnitCnt(rs
							.getBigDecimal("SV104SVC_UNIT_CNT"));
					oPrfsnSvcLine.setSv105placeSvcCd(rs
							.getString("SV105PLACE_SVC_CD"));
					oPrfsnSvcLine.setSv107diagCdPtr1(rs
							.getString("SV107DIAG_CD_PTR1"));
					oPrfsnSvcLine.setSv107diagCdPtr2(rs
							.getString("SV107DIAG_CD_PTR2"));
					oPrfsnSvcLine.setSv107diagCdPtr3(rs
							.getString("SV107DIAG_CD_PTR3"));
					oPrfsnSvcLine.setSv107diagCdPtr4(rs
							.getString("SV107DIAG_CD_PTR4"));
					if (null != rs.getString("SV109EMERGENCY_IND")
							&& rs.getString("SV109EMERGENCY_IND").length() > 0) {
						oPrfsnSvcLine.setSv109emergencyInd(rs.getString(
								"SV109EMERGENCY_IND").charAt(0));
					}
					if (null != rs.getString("SV111EPSDT_IND")
							&& rs.getString("SV111EPSDT_IND").length() > 0) {
						oPrfsnSvcLine.setSv111epsdtInd(rs.getString(
								"SV111EPSDT_IND").charAt(0));
					}
					if (null != rs.getString("SV112FMLY_PLN_IND")
							&& rs.getString("SV112FMLY_PLN_IND").length() > 0) {
						oPrfsnSvcLine.setSv112fmlyPlnInd(rs.getString(
								"SV112FMLY_PLN_IND").charAt(0));
					}
					if (null != rs.getString("SV115COPAY_STAT_CD")
							&& rs.getString("SV115COPAY_STAT_CD").length() > 0) {
						oPrfsnSvcLine.setSv115copayStatCd(rs.getString(
								"SV115COPAY_STAT_CD").charAt(0));
					}
					oPrfsnSvcLine.setSv1018prdctSvcId(rs
							.getString("SV101_8PRDCT_SVC_ID"));
					oPrfsnSvcLine.setSv101Desc(rs.getString("SV101DESC"));
					listPrfsnSvcLine.add(oPrfsnSvcLine);
				}
			}
		} catch (SQLException sqlExp) {
			LOGGER.error(
					"setPrfsnSvcLine unable to fetch Professional Services Line Details due to error:",
					sqlExp.getMessage());
		}
		LOGGER.debug("End extract Prfsn Svc Line Information");
	}

	/**
	 * 
	 */
	final void setInstSvcLine() {
		LOGGER.debug("Begin extract Inst Svc Line Information");
		String sql = "select * from INST_SVC_LINE where CLAIM_KEY = :claimKey";
		try {
			pStatement = conn.prepareStatement(sql);
			pStatement.setString(1, reposClaim.getClaimKey());
			rs = pStatement.executeQuery();
			if (null != rs) {
				InstSvcLine oInstSvcLine = null;
				listInstSvcLine = new ArrayList<InstSvcLine>();
				while (rs.next()) {
					oInstSvcLine = new InstSvcLine();
					oInstSvcLine.setClaim(reposClaim);
					oInstSvcLine.setServiceKey(rs.getString("SERVICE_KEY"));
					oInstSvcLine.setLx01asgnLnNbr(rs
							.getBigDecimal("LX01ASGN_LN_NBR"));
					oInstSvcLine.setSv201svcLnRevCd(rs
							.getString("SV201SVC_LN_REV_CD"));
					oInstSvcLine.setSv202svcIdQual(rs
							.getString("SV202SVC_ID_QUAL"));
					oInstSvcLine.setSv202procCd(rs.getString("SV202PROC_CD"));
					oInstSvcLine.setSv202procMod1(rs
							.getString("SV202PROC_MOD1"));
					oInstSvcLine.setSv202procMod2(rs
							.getString("SV202PROC_MOD2"));
					oInstSvcLine.setSv202procMod3(rs
							.getString("SV202PROC_MOD3"));
					oInstSvcLine.setSv202procMod4(rs
							.getString("SV202PROC_MOD4"));
					oInstSvcLine.setSv203lnItmChrg(rs
							.getBigDecimal("SV203LN_ITM_CHRG"));
					oInstSvcLine.setSv204uomCd(rs.getString("SV204UOM_CD"));
					oInstSvcLine.setSv205svcUnitCnt(rs
							.getBigDecimal("SV205SVC_UNIT_CNT"));
					oInstSvcLine.setSv206svcLnRt(rs
							.getBigDecimal("SV206SVC_LN_RT"));
					oInstSvcLine.setSv207denyChrgAmt(rs
							.getBigDecimal("SV207DENY_CHRG_AMT"));
					oInstSvcLine.setSv2028prdctSvcId(rs
							.getString("SV202_8PRDCT_SVC_ID"));
					oInstSvcLine.setSv202Desc(rs.getString("SV202DESC"));
					listInstSvcLine.add(oInstSvcLine);
				}
			}
		} catch (SQLException sqlExp) {
			LOGGER.error(
					"setInstSvcLine unable to fetch Institutional Services Line Details due to error:",
					sqlExp.getMessage());
		}
		LOGGER.debug("End extract Inst Svc Line Information");
	}

	/**
	 * 
	 */
	final void setDentalSvcLine() {
		LOGGER.debug("Begin extract Dental Svc Line Information");
		String sql = "select * from DENTAL_SVC_LINE where CLAIM_KEY = :claimKey";
		try {
			pStatement = conn.prepareStatement(sql);
			pStatement.setString(1, reposClaim.getClaimKey());
			rs = pStatement.executeQuery();
			if (null != rs) {
				DentalSvcLine oDentalSvcLine = null;
				listDentalSvcLine = new ArrayList<DentalSvcLine>();
				while (rs.next()) {
					oDentalSvcLine = new DentalSvcLine();
					oDentalSvcLine.setClaim(reposClaim);
					oDentalSvcLine.setServiceKey(rs.getString("SERVICE_KEY"));
					oDentalSvcLine.setLx01asgnLnItm(rs
							.getBigDecimal("LX01ASGN_LN_ITM"));
					oDentalSvcLine.setSv301adaCdQual(rs
							.getString("SV301ADA_CD_QUAL"));
					oDentalSvcLine.setSv301adaCd(rs.getString("SV301ADA_CD"));
					oDentalSvcLine.setSv301procMod1(rs
							.getString("SV301PROC_MOD1"));
					oDentalSvcLine.setSv301procMod2(rs
							.getString("SV301PROC_MOD2"));
					oDentalSvcLine.setSv301procMod3(rs
							.getString("SV301PROC_MOD3"));
					oDentalSvcLine.setSv301procMod4(rs
							.getString("SV301PROC_MOD4"));
					oDentalSvcLine.setSv302lnItmChrg(rs
							.getBigDecimal("SV302LN_ITM_CHRG"));
					oDentalSvcLine.setSv303fclyTypeCd(rs
							.getString("SV303FCLY_TYPE_CD"));
					oDentalSvcLine.setSv304oralDsgt1(rs
							.getString("SV304ORAL_DSGT1"));
					oDentalSvcLine.setSv304oralDsgt2(rs
							.getString("SV304ORAL_DSGT2"));
					oDentalSvcLine.setSv304oralDsgt3(rs
							.getString("SV304ORAL_DSGT3"));
					oDentalSvcLine.setSv304oralDsgt4(rs
							.getString("SV304ORAL_DSGT4"));
					oDentalSvcLine.setSv304oralDsgt5(rs
							.getString("SV304ORAL_DSGT5"));
					if (null != rs.getString("SV305PLCMT_CD")
							&& rs.getString("SV305PLCMT_CD").length() > 0) {
						oDentalSvcLine.setSv305plcmtCd(rs.getString(
								"SV305PLCMT_CD").charAt(0));
					}
					oDentalSvcLine.setSv306procCnt(rs
							.getBigDecimal("SV306PROC_CNT"));
					oDentalSvcLine.setSv311diagPntr1(rs
							.getByte("SV311DIAG_PNTR1"));
					oDentalSvcLine.setSv311diagPntr2(rs
							.getByte("SV311DIAG_PNTR2"));
					oDentalSvcLine.setSv311diagPntr3(rs
							.getByte("SV311DIAG_PNTR3"));
					oDentalSvcLine.setSv311diagPntr4(rs
							.getByte("SV311DIAG_PNTR4"));
					oDentalSvcLine.setSv301Desc(rs.getString("SV301DESC"));
					listDentalSvcLine.add(oDentalSvcLine);
				}
			}
		} catch (SQLException sqlExp) {
			LOGGER.error("", sqlExp.getMessage());
		}
		LOGGER.debug("End extract Dental Svc Line Information");
	}
}
