package gov.va.med.hac.edi.extract.x214;

import gov.va.med.hac.edi.extract.feeclaimstatus.feeFinal.PaymentDataExtraction;

import java.io.File;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityTransaction;
import javax.persistence.Query;

import org.hibernate.Session;
import org.hibernate.connection.ConnectionProvider;
import org.hibernate.engine.SessionFactoryImplementor;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * 
 * @author DNS
 *
 */
public class HCCA277GenerationHelper extends Build277CASegments {
	/** the class logger. */
	static final Logger LOGGER = LoggerFactory
			.getLogger(HCCA277GenerationHelper.class);
	static boolean DEBUG = false;
	int fileGroupCount = 1;
	int fileGroupSequenceNumber = 0;
	int curFileNumber = 0;
	PaymentDataExtraction paymentDataExtraction = null;
	String ereposClaimKey = "";
	String fileNbr = "";
	String st02CtlNbr = "";
	String billPrvdId = "";
	String sbcrId = "";
	String claimType = "";
	String statusCd = "";
	String currentDate = "";
	String currentTime = "";
	String strFileTime = "";
	boolean bHeader = false;

	/**
	 * 
	 * @param beginDate
	 * @param endDate
	 * @param outputDir
	 * @param entityManager
	 */
	final void processByDate(Date beginDate, Date endDate, String outputDir,
			EntityManager entityManager) {
		if (null == conn) {
			getConnection(entityManager);
		}
		List<String> batchArray = getBatchIDs(beginDate, endDate);
		for (String eachBatchId : batchArray) {
			processByBatchID(eachBatchId, outputDir, entityManager);
		}
	}

	/**
	 * 
	 * @param batchNumber
	 * @param outputDir
	 * @param entityManager
	 */
	final void processByBatchID(String batchNumber, String outputDir,
			EntityManager entityManager) {
		filePath = outputDir;
		if (null == conn) {
			getConnection(entityManager);
		}
		EntityTransaction tx = em.getTransaction();
		try {
			tx.begin();
			fileNbr = batchNumber;
			setEreposClaim(fileNbr);
			bHeader = false;
			if (claims != null) {
				bHeader = false;
				while (claims.next()) {
					reposClaim = (gov.va.med.domain.erepos.Claim) claims.get(0);
					// System.out.println("Claim Key is: "+reposClaim.getClaimKey());
					 if (reposClaim.getClaimKey().equals(
					 "2347B27D-3C47-8C9F-E050-BF0A4A1008D6")) {
					if (null != reposClaim.getStatusCode()
							&& (reposClaim.getStatusCode().equalsIgnoreCase(
									ACCEPTED)
									|| reposClaim.getStatusCode()
											.equalsIgnoreCase(
													ACCEPTED_WITH_ERRORS) || reposClaim
									.getStatusCode().equalsIgnoreCase(REJECTED))) {
						sClaimKey = reposClaim.getClaimKey();
						setEntityInfo();
						setEntityAdtlId();
						setSVC();
						if (null != senderInfo) {
							setEReposClaim(sClaimKey);
							if (bHeader == false) {
								csFile = createNewOutputFile(fileNbr, filePath);
								vCsFile = new PrintWriter(new FileOutputStream(
										csFile));
								createISAHeaderBatch();
								createGSBatch();
								bHeader = true;
							}
							createST();
							createBHT();
							createHL1();
							createNM1_1();
							createTRN1();
							createDTP1();
							createDTP2();
							createHL2();
							createNM1_2();
							createTRN2();
							createSTC1();
							createQTY();
							createAMT();
							createHL3();
							createNM1_3();
							createTRN3();
							createSTC2();
							createHL4();
							createNM1_4();
							createTRN4();							
							createSTC3();
							createReceiverREF();
							createBillingREF();
							createClaimREF();
							createDTP();
							if(REJECTED.equalsIgnoreCase(reposClaim.getStatusCode()))
							{
								createStatusLineInfo();								
							}
							createSE();
							persist277CA();
							persist277CAStatus();
						}
					}
				}
				if (bHeader != false) {
					createGEBatch();
					createIEABatch();
					vCsFile.flush();
					vCsFile.close();
				}
			}
			}
			tx.commit();
		} catch (Exception ex) {
			ex.printStackTrace();
			LOGGER.error(
					"processClaimStatus() - Unable to create CSTAT, errored on Claim Key: {}",
					this.claimKey);
			tx.rollback();
			LOGGER.error(ex.getMessage(), ex);
		}
	}

	/**
	 * 
	 * @param entityManager
	 */
	private void getConnection(EntityManager entityManager) {
		try {
			em = entityManager;
			oSession = (Session) entityManager.getDelegate();
			SessionFactoryImplementor sfi = (SessionFactoryImplementor) oSession
					.getSessionFactory();
			ConnectionProvider cp = sfi.getConnectionProvider();
			conn = cp.getConnection();
		} catch (SQLException sqlExp) {
			LOGGER.error(
					"getConnection() - Unable to get Connection using the Configuraiton Provided",
					sqlExp);
		}
	}

	/**
	 * 
	 */
	private void setEReposClaim(String sClaimKey) {
		String reposStr = "Select e from eClaim e where e.claimKey = :ediClaimKey";
		Query qErepos = null;
		try {
			if (DEBUG) {
				System.out
						.println("\nCreatePrimaryDetailRec() - calling getting eReposClaimInfo  at....");
				getNow();
			}
			qErepos = em.createQuery(reposStr);
			qErepos.setParameter("ediClaimKey", sClaimKey);
			// use this claim to handle information from e_repos schema
			reposClaim = (gov.va.med.domain.erepos.Claim) qErepos
					.getSingleResult();
			// if above is successful, get properties below......
		} catch (Exception e) {
			LOGGER.error(
					"createPrimaryDetailRec() - Error getting claim info on Claim Key: {}",
					this.sClaimKey);
			LOGGER.error(e.getMessage(), e);
		} finally {
			qErepos = null;
		}
	}

	/**
	 * to do: put header and footer on EACH file, numbering starts over on each
	 * output file
	 *
	 * Creates a new output file
	 * 
	 * @param filePath
	 *            variable read from command line args
	 * @return File
	 */
	private File createNewOutputFile(String strClaimKey, String filePath) {
		File csFile = null;
		try {
			Calendar cal = new GregorianCalendar();
			String currentDate = "";
			String currentTime = "";
			SimpleDateFormat transDate = new SimpleDateFormat("yyyyMMdd");
			SimpleDateFormat transTime = new SimpleDateFormat("HHmmss");
			currentDate = transDate.format(cal.getTime());
			currentTime = transTime.format(cal.getTime());
			this.strFileTime = currentDate + currentTime;
			String fileName = "";
			if (null != strClaimKey && strClaimKey.length() > 0) {
				fileName = strClaimKey + "_" + currentDate + currentTime + "_"
						+ "277CA" + ".edi";
			} else {
				fileName = currentDate + currentTime + "_" + "277CA" + ".edi";
			}
			// increment output items.....
			this.fileGroupCount++;
			this.fileGroupSequenceNumber++;
			csFile = new File(filePath + fileName);
			curFileNumber++;
		} catch (Exception ex) {
			LOGGER.error(
					"Error on createNewOutputFile(), UNABLE TO CREATE NEW OUTPUT FILE - CURRENT fileGroupCount is: ",
					this.fileGroupCount);
			LOGGER.error(ex.getMessage(), ex);
		}

		return csFile;
	} // end createNewOutputFile()
}
